clear all
capture log close
set more off 


cd "C:\Personal\study\research\2022.04 wage gap\cdr\result"
dir


use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2.dta", clear 


gl maexp exp exp2
gl matenure tenure tenure2 
gl hc_conti eduy $maexp
gl hc_dummy train 
gl hc eduy $maexp train 
gl hcp1 eduy $matenure train 
gl hcp2 cedul2-cedul5 $maexp train 
gl hcp3 cedul2-cedul5 $matenure train 

gl demo_dummy female mino rural native mangood diagood phygood mengood pm child 
gl demo_cate cmarr2 cmarr3 
gl demo $demo_dummy $demo_cate 

gl occu_dummy dispatch contr um 
gl occu_cate cjobt2 cjobt3 
gl occu $occu_dummy $occu_cate 

gl firm_conti f_age lavrwage lrevenue age_ceo
gl firm_dummy female_ceo pm_ceo gov_ceo
gl firm_cate csize2 csize3 cedul_ceo2 cedul_ceo3 cedul_ceo4 cedul_ceo5
gl firm $firm_conti $firm_dummy $firm_cate 

gl firm_conti_alter f_age lavrwage lrevenue 
gl firm_cate_alter csize2 csize3 
gl firm_alter $firm_conti_alter $firm_cate_alter 

gl feind cind2 cind3 cind4 cind5
gl fey cy2 cy3
gl feprefecture cprefecture2 cprefecture3 cprefecture4 cprefecture5 cprefecture6  
gl fep_y cp1_y2 cp1_y3 /* 
      */ cp2_y1 cp2_y2 cp2_y3 /* 
	  */ cp3_y1 cp3_y2 cp3_y3 /* 
	  */ cp4_y1 cp4_y2 /* 
	  */ cp5_y1 cp5_y2 cp5_y3 /* 
	  */ cp6_y1 cp6_y2 cp6_y3 // 
gl fe $feind $fey $feprefecture $fep_y 
gl fe_alter $feind $fey $feprefecture 

gl cv $hc_conti $firm_conti 
gl bv $hc_dummy $demo $occu $firm_cate $feyear $feind $feprefecture  

gl ctrl $cv $bv
gl ctrlp $cvp $bv

gl graph_opts graphregion(color(white)) ylab(, angle(0) nogrid) yscale(noline) xscale(noline) legend(region(lc(none) fc(none))) 



/*============================================================================*/


//summary statistics
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2.dta", clear

foreach x in "lwr" "soe" ///
             "eduy" "exp" "tenure" "train" ///
			 "female" "mino" "rural" "native" "pm" "cmarr1" "cmarr2" "cmarr3" "child" "cjobt1" "cjobt2" "cjobt3" "dispatch" "contr" "um" /// 
             "lrevenue" "lavrwage" "f_age" "csize1" "csize2" "csize3" "cind1" "cind2" "cind3" "cind4" "cind5" {
    qui sum `x' 
	if ("`x'"!="lwr") & ("`x'"!="eduy") & ("`x'"!="exp") & ("`x'"!="tenure") & ("`x'"!="lrevenue") & ("`x'"!="lavrwage") & ("`x'"!="f_age") {
	    loc m`x' = string(100*r(mean), "%4.2f")
	}	
	else loc m`x' = string(r(mean), "%4.3f")
	loc sd`x' = string(r(sd), "%4.3f") 
	
	forv i = 0/1 {
	    qui sum `x' if (soe==`i')
		if ("`x'"!="lwr") & ("`x'"!="eduy") & ("`x'"!="exp") & ("`x'"!="tenure") & ("`x'"!="lrevenue") & ("`x'"!="lavrwage") & ("`x'"!="f_age") {
	        loc m`x'`i' = string(100*r(mean), "%4.2f")
	    }
	    else loc m`x'`i' = string(r(mean), "%4.3f")
	    loc sd`x'`i' = string(r(sd), "%4.3f")    
	}
}

tempfile table
tempname dtades

postfile `dtades' str200(Varname) str200(Mean Mean_Soe Mean_Nsoe) using `table', replace 
foreach x of var lwr soe ///
                 eduy exp tenure train ///
				 female mino rural native pm cmarr* child cjobt* dispatch contr um /// 
                 lrevenue lavrwage f_age csize* cind1-cind5 {
    post `dtades' ("`x'") ("`m`x''") ("`m`x'1'") ("`m`x'0'")  
	post `dtades' ("") ("(`sd`x'')") ("(`sd`x'1')") ("(`sd`x'0')")
}
					   
postclose `dtades'

use `table', clear
export excel using dtades_2, replace firstrow(variables)


use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2.dta", clear

foreach x in "lwr" "soe" ///
             "eduy" "exp" "tenure" "train" ///
			 "female" "mino" "rural" "native" "pm" "cmarr1" "cmarr2" "cmarr3" "child" "cjobt1" "cjobt2" "cjobt3" "dispatch" "contr" "um" /// 
             "lrevenue" "lavrwage" "f_age" "csize1" "csize2" "csize3" "cind1" "cind2" "cind3" "cind4" "cind5" {
    qui	reg `x' soe 
	if ("`x'"=="lwr") outreg2 using dtades_gap_2, excel dec(3) replace
	else if ("`x'"!="eduy") & ("`x'"!="exp") & ("`x'"!="tenure") & ("`x'"!="lrevenue") & ("`x'"!="lavrwage") & ("`x'"!="f_age") {
	    outreg2 using dtades_gap_2, excel dec(4) append
	}
	else outreg2 using dtades_gap_2, excel dec(3) append
}



/*============================================================================*/



//stepwise
/*raw gap*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_0.dta", clear 


sqreg lwr soe, q(.1 .2 .3 .4 .5 .6 .7 .8 .9) r(20) 
gr set window fontface "Times New Roman" 
gr set window fontfacesans "宋体"
qregplot soe, ols olsopt(vce(robust)) raopt(color(black%5)) lnopt(lp(longdash_dot)) ///
    twopt ( ///
	$graph_opts ///
	ylab(, labs(medsmall)) ///
	xlab(10(10)90, labs(medsmall)) ///
	tit("") ///
	yti("{stSans:工}""{stSans:资}""{stSans:差}""{stSans:异}", orientation(h) nobox place(9) si(medsmall)) ///
	xti("{stSans:工资百分位}", nobox place(6) si(medsmall)) /// 
	ysc(line) ///
	xsc(line) ///
	legend(on order(2 3) label(2 "{stSans:工资差分位数估计}") label(3 "{stSans:工资差}""{stSans:OLS}""{stSans:估计}") symy(*.25) r(1) si(medsmall) span))
gr save "Graph" "C:\Personal\study\research\2022.04 wage gap\cdr\code\raw gap_2.gph", replace
gr export "C:\Personal\study\research\2022.04 wage gap\cdr\result\raw wage gap.png", as(png) name("Graph") replace 

cap graph drop _all


/*raw*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_0.dta", clear  

reg lwr soe $fe, r 
outreg2 using reg_sw_2, excel dec(3) ct("raw-ols") replace 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    capture: qreg lwr soe $fe, q(`q') vce(r, ker(tri))
	outreg2 using reg_sw_2, excel dec(3) ct("raw-`q'") append
}


/*+hc*/ 
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_1.dta", clear

reg lwr soe $hc $fe, r 
outreg2 using reg_sw_2, excel dec(3) ct("hc-ols") append 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    capture: qreg lwr soe $hc $fe, q(`q') vce(r, ker(tri))
	outreg2 using reg_sw_2, excel dec(3) ct("hc-`q'") append
}


/*+demo*/
reg lwr soe $hc $demo $fe, r 
outreg2 using reg_sw_2, excel dec(3) ct("demo-ols") append

foreach q in ".10" ".25" ".50" ".75" ".90" {
    capture: qreg lwr soe $hc $demo $fe, q(`q') vce(r, ker(tri))
	outreg2 using reg_sw_2, excel dec(3) ct("demo-`q'") append
}


/*+occu*/
reg lwr soe $hc $demo $occu $fe, r 
outreg2 using reg_sw_2, excel dec(3) ct("occu-ols") append 

foreach q in ".10" ".25" ".50" ".75" ".90" {
   capture: qreg lwr soe $hc $demo $occu $fe, q(`q') vce(r, ker(tri)) 
   outreg2 using reg_sw_2, excel dec(3) ct("occu-`q'") append
}


/*
/*+lrevenue*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2.dta", clear  

reg lwr soe $hc $demo $occu lrevenue $fe, r 
outreg2 using reg_sw_2, excel dec(3) ct("lrevenue-ols") append 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    qreg lwr soe $hc $demo $occu lrevenue $fe, q(`q') vce(r)
	outreg2 using reg_sw_2, excel dec(3) ct("lrevenue-`q'") append
}


/*+firm_other*/
reg lwr soe $hc $demo $occu $firm $fe, r 
outreg2 using reg_sw_2, excel dec(3) ct("firm_other-ols") append 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    qreg lwr soe $hc $demo $occu $firm $fe, q(`q') vce(r)
	outreg2 using reg_sw_2, excel dec(3) ct("firm_other-`q'") append
}
*/


/*+firm*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2.dta", clear  

reg lwr soe $hc $demo $occu $firm $fe, r 
outreg2 using reg_sw_2, excel dec(3) ct("firm-ols") append 

foreach q in ".10" ".25" ".50" ".75" ".90" {
	capture: qreg lwr soe $hc $demo $occu $firm $fe, q(`q') vce(r, ker(tri)) 
	outreg2 using reg_sw_2, excel dec(3) ct("firm-.10") append
}


/*
foreach q in ".10" ".25" ".50" ".75" ".90" {
    qreg lwr soe $hc $demo $occu $firm $fe, q(`q') vce(r)
	outreg2 using reg_sw_2, excel dec(3) ct("firm_other-`q'") append
}
*/


/*+score*/
reg lwr soe $hc $demo score* $occu $firm $fe, r 
outreg2 using reg_sw_2, excel dec(3) ct("score-ols") append 

foreach q in ".10" ".25" ".50" ".75" ".90" {
	capture: qreg lwr soe $hc $demo score* $occu $firm $fe, q(`q') vce(r, ker(tri)) 
	outreg2 using reg_sw_2, excel dec(3) ct("score-.10") append
}


/*----------------------------------------------------------------------------*/


/*iv*/
{
eststo model1: ivreg2 lwr $hc $demo $occu $firm $fe (soe = decentf), first r savefirst savefprefix(f1)
estadd sca F = `e(widstat)': f1soe
esttab f1soe model1 using reg_iv_2.doc, se scalar(F) drop($hc $demo $occu $firm $fe) star(* 0.05 ** 0.01 *** 0.001) b(3) replace 

eststo model2: ivreg2 lwr $hc $demo $occu $firm $fe (soe = decentp), first r savefirst savefprefix(f2)
estadd sca F = `e(widstat)': f2soe
esttab f2soe model2 using reg_iv_2.doc, se scalar(F) drop($hc $demo $occu $firm $fe) star(* 0.05 ** 0.01 *** 0.001) b(3) append 
}

{
eststo model1: ivreg2 lwr $hc $demo $occu $firm_alter $fe_alter (soe = decentf), first r savefirst savefprefix(f1)
estadd sca F = `e(widstat)': f1soe
esttab f1soe model1 using reg_iv_alter_2.doc, se scalar(F) drop($hc $demo $occu $firm_alter $fe_alter) star(* 0.05 ** 0.01 *** 0.001) b(3) replace 

eststo model2: ivreg2 lwr $hc $demo $occu $firm_alter $fe_alter (soe = decentp), first r savefirst savefprefix(f2)
estadd sca F = `e(widstat)': f2soe
esttab f2soe model2 using reg_iv_alter_2.doc, se scalar(F) drop($hc $demo $occu $firm_alter $fe_alter) star(* 0.05 ** 0.01 *** 0.001) b(3) append 
}



/*============================================================================*/



//decomposition
/*ob*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2.dta", clear    
	    
oaxaca9 lwr $hc $demo_dummy $occu_dummy $firm_conti $firm_dummy, by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p 
outreg2 using decomp_ob_2, excel dec(3) replace
	
mat drop _all
mat b = e(b) 
sca gap_ob = b[1, 3]
sca coe_ob = b[1, 5] 
sca coeshare_ob = coe_ob/gap_ob
sca coesharestr_ob = strofreal(coeshare_ob*100, "%4.2f")+"%" 

tempfile table
tempname decomp_ob_share

postfile `decomp_ob_share' str200(share) using `table', replace 

post `decomp_ob_share' (coesharestr_ob) 

postclose `decomp_ob_share'
use `table', clear
export excel using decomp_ob_share_2, replace firstrow(variables)


/*----------------------------------------------------------------------------*/


/*cdeco*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2.dta", clear
	
recode soe (0 = 1) (1 = 0), gen(nsoe) 
	    
cdeco lwr $hc $demo $occu $firm $fe, g(nsoe) q(.1 .2 .25 .3 .4 .5 .6 .7 .75 .8 .9) 
outreg2 using decomp_qd_2, excel dec(3) replace 

{	
mat drop _all
mat b = e(b) 
        
forv i = 1/11 {
    sca gap`i'_qd = b[1, `i']
    sca coe`i'_qd = b[1, `i'+22] 
    sca coeshare`i'_qd = coe`i'_qd/gap`i'_qd
    sca coeshare`i'str_qd = strofreal(coeshare`i'_qd*100, "%4.2f")+"%" 
}
}

{
mat result_mm = J(9, 4, 0)

forv i = 1/9 {
	mat result_mm[`i', 1] = 10*`i' 
}

forv i = 1/9 {
	forv j = 2/4 {
		if (`i'<=2) {
		    mat result_mm[`i', `j'] = b[1, `i'+(`j'-2)*11]
	    }
	    else if (`i'<=7) {
		    mat result_mm[`i', `j'] = b[1, `i'+1+(`j'-2)*11]
	    }
	    else mat result_mm[`i', `j'] = b[1, `i'+2+(`j'-2)*11]
	}
}

putexcel set decompresult.xlsx, replace
putexcel A2 = matrix(result_mm), overwr 
}

{
tempfile table
tempname decomp_qd_share

postfile `decomp_qd_share' str200(share_q10 share_q20 share_q25 share_q30 share_q40 share_q50 share_q60 share_q70 share_q75 share_q80 share_q90) using `table', replace 

post `decomp_qd_share' (coeshare1str_qd) (coeshare2str_qd) (coeshare3str_qd) (coeshare4str_qd) (coeshare5str_qd) (coeshare6str_qd) (coeshare7str_qd) (coeshare8str_qd) (coeshare9str_qd) (coeshare10str_qd) (coeshare11str_qd) 

postclose `decomp_qd_share'
use `table', clear
export excel using decomp_qd_share_2, replace firstrow(variables)
}


/******************************************************************************/


use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2.dta", clear
	
recode soe (0 = 1) (1 = 0), gen(nsoe) 
	    
cdeco lwr $hc $demo $occu $firm_alter $fe_alter, g(nsoe) q(.1 .2 .25 .3 .4 .5 .6 .7 .75 .8 .9) 
outreg2 using decomp_qd_alter_2, excel dec(3) replace 

{	
mat drop _all
mat b = e(b) 
        
forv i = 1/11 {
    sca gap`i'_qd_alter = b[1, `i']
    sca coe`i'_qd_alter = b[1, `i'+22] 
    sca coeshare`i'_qd_alter = coe`i'_qd_alter/gap`i'_qd_alter
    sca coeshare`i'str_qd_alter = strofreal(coeshare`i'_qd_alter*100, "%4.2f")+"%" 
}
}

{
mat result_mm_alter = J(9, 4, 0)

forv i = 1/9 {
	mat result_mm_alter[`i', 1] = 10*`i' 
}

forv i = 1/9 {
	forv j = 2/4 {
		if (`i'<=2) {
		    mat result_mm_alter[`i', `j'] = b[1, `i'+(`j'-2)*11]
	    }
	    else if (`i'<=7) {
		    mat result_mm_alter[`i', `j'] = b[1, `i'+1+(`j'-2)*11]
	    }
	    else mat result_mm_alter[`i', `j'] = b[1, `i'+2+(`j'-2)*11]
	}
}

putexcel set decompresult_alter.xlsx, replace
putexcel A2 = matrix(result_mm_alter), overwr 
}

{
tempfile table
tempname decomp_qd_share_alter

postfile `decomp_qd_share_alter' str200(share_q10 share_q20 share_q25 share_q30 share_q40 share_q50 share_q60 share_q70 share_q75 share_q80 share_q90) using `table', replace 

post `decomp_qd_share_alter' (coeshare1str_qd_alter) (coeshare2str_qd_alter) (coeshare3str_qd_alter) (coeshare4str_qd_alter) (coeshare5str_qd_alter) (coeshare6str_qd_alter) (coeshare7str_qd_alter) (coeshare8str_qd_alter) (coeshare9str_qd_alter) (coeshare10str_qd_alter) (coeshare11str_qd_alter) 

postclose `decomp_qd_share_alter'
use `table', clear
export excel using decomp_qd_share_alter_2, replace firstrow(variables)
}



/*============================================================================*/



//robustness 
/*se*/
/*
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_0.dta", clear  

reg lwr soe $fe, cluster(fid)
outreg2 using robust_sw_se_2, excel dec(3) ct("raw-ols") replace 

foreach bwidth in "hs" "bo" "ch" {
    foreach denmethod in "fit" "ker(ep)" "ker(epan2)" "ker(bi)" "ker(cos)" "ker(gau)" "ker(par)" "ker(rec)" "ker(tri)" {
        foreach q in ".10" ".25" ".50" ".75" ".90" {
            qreg lwr soe $fe, q(`q') vce(r, `denmethod' `bwidth')
            outreg2 using robust_sw_se_2, excel dec(3) ct("raw-`bwidth'-`denmethod'-`q'") append
		}
    }
}


use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_1.dta", clear
	
reg lwr soe $hc $fe, cluster(fid)
outreg2 using robust_sw_se_2, excel dec(3) ct("hc-ols") append 

foreach bwidth in "hs" "bo" "ch" {
	foreach denmethod in "fit" "ker(ep)" "ker(epan2)" "ker(bi)" "ker(cos)" "ker(gau)" "ker(par)" "ker(rec)" "ker(tri)" {
	    foreach q in ".10" ".25" ".50" ".75" ".90" {
            qreg lwr soe $hc $fe, q(`q') vce(r, `denmethod' `bwidth')
            outreg2 using robust_sw_se_2, excel dec(3) ct("hc-`bwidth'-`denmethod'-`q'") append
	    }
    }
}
	
reg lwr soe $hc $demo $fe, cluster(fid) 
outreg2 using robust_sw_se_2, excel dec(3) ct("demo-ols") append

foreach bwidth in "hs" "bo" "ch" {
	foreach denmethod in "fit" "ker(ep)" "ker(epan2)" "ker(bi)" "ker(cos)" "ker(gau)" "ker(par)" "ker(rec)" "ker(tri)" {
	    foreach q in ".10" ".25" ".50" ".75" ".90" {
            qreg lwr soe $hc $demo $fe, q(`q') vce(r, `denmethod' `bwidth')
            outreg2 using robust_sw_se_2, excel dec(3) ct("demo-`bwidth'-`denmethod'-`q'") append
		}
    }
}
	
reg lwr soe $hc $demo $occu $fe, cluster(fid) 
outreg2 using robust_sw_se_2, excel dec(3) ct("occu-ols") append 

foreach bwidth in "hs" "bo" "ch" {
    foreach denmethod in "fit" "ker(ep)" "ker(epan2)" "ker(bi)" "ker(cos)" "ker(gau)" "ker(par)" "ker(rec)" "ker(tri)" {
	    foreach q in ".10" ".25" ".50" ".75" ".90" {
            qreg lwr soe $hc $demo $occu $fe, q(`q') vce(r, `denmethod' `bwidth')
            outreg2 using robust_sw_se_2, excel dec(3) ct("occu-`bwidth'-`denmethod'-`q'") append
        }
    }
}

	
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2.dta", clear 
	
reg lwr soe $hc $demo $occu lrevenue $fe, cluster(fid) 
outreg2 using robust_sw_se_2, excel dec(3) ct("lrevenue-ols") append 

foreach bwidth in "hs" "bo" "ch" {
	foreach denmethod in "fit" "ker(ep)" "ker(epan2)" "ker(bi)" "ker(cos)" "ker(gau)" "ker(par)" "ker(rec)" "ker(tri)" {
	    foreach q in ".10" ".25" ".50" ".75" ".90" {
            qreg lwr soe $hc $demo $occu lrevenue $fe, q(`q') vce(r, `denmethod' `bwidth')
            outreg2 using robust_sw_se_2, excel dec(3) ct("lrevenue-`bwidth'-`denmethod'-`q'") append
        }
    }
}
	
reg lwr soe $hc $demo $occu $firm $fe, cluster(fid) 
outreg2 using robust_sw_se_2, excel dec(3) ct("firm_other-ols") append 

foreach bwidth in "hs" "bo" "ch" {
    foreach denmethod in "fit" "ker(ep)" "ker(epan2)" "ker(bi)" "ker(cos)" "ker(gau)" "ker(par)" "ker(rec)" "ker(tri)" {
	    foreach q in ".10" ".25" ".50" ".75" ".90" {
            qreg lwr soe $hc $demo $occu $firm $fe, q(`q') vce(r, `denmethod' `bwidth')
            outreg2 using robust_sw_se_2, excel dec(3) ct("firm_other-`bwidth'-`denmethod'-`q'") append
        }
    }
}
*/


{
foreach omega in "reimers" "cotton" {
    if ("`omega'"=="reimers") oaxaca9 lwr $hc $demo_dummy $occu_dummy $firm_conti $firm_dummy, by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) w(.5)
	else oaxaca9 lwr $hc $demo_dummy $occu_dummy $firm_conti $firm_dummy, by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) w(.77)
	
	if ("`omega'"=="reimers") outreg2 using decomp_r&c_2, excel dec(3) ct("reimers") replace 
	else outreg2 using decomp_r&c_2, excel dec(3) ct("cotton") append 
	
    mat drop _all
    mat b = e(b) 
    sca gap_`omega' = b[1, 3]
    sca coe_`omega' = b[1, 5] 
    sca coeshare_`omega' = coe_`omega'/gap_`omega'
    sca coesharestr_`omega' = strofreal(coeshare_`omega'*100, "%4.2f")+"%" 
}

tempfile table
tempname decomp_rc_share

postfile `decomp_rc_share' str200(share_reimers share_cotton) using `table', replace 

post `decomp_rc_share' (coesharestr_reimers) (coesharestr_cotton) 

postclose `decomp_rc_share'
use `table', clear
export excel using decomp_r&c_share_2, replace firstrow(variables)
}


{
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2.dta", clear

foreach q in "10" "20" "25" "30" "40" "50" "60" "70" "75" "80" "90" {
    bootstrap, r(100): oaxaca_rif lwr $hc $demo_dummy $occu_dummy $firm_conti $firm_dummy n(cmarr*) n(cjobt*) n(csize*) n(cedul_ceo*) n(cy*) n(cind1-cind5) n(cprefecture*) n(cp?_y?), by(soe) wgt(1) rif(q(`q')) swap relax
    if ("`q'"=="10") outreg2 using decomp_rif_2, excel dec(3) ct("q(10)") replace
	else outreg2 using decomp_rif_2, excel dec(3) ct("q(`q')") append 
	
    mat drop _all  
	mat b = e(b) 
	
	sca gap`q'_ffl = b[1, 3]
	sca cha`q'_ffl = b[1, 4]
	sca coe`q'_ffl = b[1, 5]
	sca coeshare`q'_ffl = coe`q'_ffl/gap`q'_ffl
	sca coeshare`q'str_ffl = strofreal(coeshare`q'_ffl*100, "%4.2f")+"%"
}

mat drop _all
mat result_ffl = J(9, 3, 0)

forv i = 1/9 {
	loc q = `i'*10 
	
	mat result_ffl[`i', 1] = gap`q'_ffl 
	mat result_ffl[`i', 2] = cha`q'_ffl
	mat result_ffl[`i', 3] = coe`q'_ffl
}    

putexcel set decompresult.xlsx, modify
putexcel E2 = matrix(result_ffl), overwr 

{
tempfile table
tempname decomp_rif_share

postfile `decomp_rif_share' str200(share_q10 share_q20 share_q25 share_q30 share_q40 share_q50 share_q60 share_q70 share_q75 share_q80 share_q90) using `table', replace 

post `decomp_rif_share' (coeshare10str_ffl) (coeshare20str_ffl) (coeshare25str_ffl) (coeshare30str_ffl) (coeshare40str_ffl) (coeshare50str_ffl) (coeshare60str_ffl) (coeshare70str_ffl) (coeshare75str_ffl) (coeshare80str_ffl) (coeshare90str_ffl) 

postclose `decomp_rif_share'
use `table', clear
export excel using decomp_rif_share_2, replace firstrow(variables)
}
}


{
import exc using "C:\Personal\study\research\2022.04 wage gap\cdr\result\decompresult.xlsx", clear first 

gr set window fontface "Times New Roman" 
gr set window fontfacesans "宋体"

foreach mthd in "MM" "FFL" {
	cap gr drop decomp_`mthd'
	
	tw (line gap_`mthd' q, lc(black) lp(solid)) ///
       (scatter gap_`mthd' q, mc(black) msym(oh)) ///
       (line cha_`mthd' q, lc(black) lp(dash)) /// 
       (scatter cha_`mthd' q, mc(black) msym(th)) ///
       (line coe_`mthd' q, lc(black) lp(shortdash_dot)) ///
       (scatter coe_`mthd' q, mc(black) msym(dh)), ///
       $graph_opts ///
       ylab(0(.2).6, labs(medsmall)) ///
       xlab(10(10)90, labs(medsmall)) /// 
       ti("{stSans:`mthd'分解}", nobox pos(12) si(medlarge)) ///
       yti("{stSans:工}""{stSans:资}""{stSans:差}""{stSans:异}", orientation(h) nobox place(9) si(med)) ///
       xti("{stSans:工资百分位}", nobox place(6) si(med)) /// 
       ysc(r(-.05(.05).6) line) ///
       xsc(line) ///
       legend(on order(2 4 6) label(2 "{stSans:工资总差异}") label(4 "{stSans:禀赋效应}") label(6 "{stSans:溢价效应}") symy(*.25) r(1) si(small) span) ///
       name(decomp_`mthd') 
}

cap graph drop decomp
grc1leg decomp_MM decomp_FFL, ///
    r(1) ///
	graphregion(color(white)) ///
	leg(decomp_MM) pos(6) span /// 
	name(decomp) 

gr save "decomp" "C:\Personal\study\research\2022.04 wage gap\cdr\code\compare_decomp_2.gph", replace
gr export "C:\Personal\study\research\2022.04 wage gap\cdr\result\comparation between MM & FFL.png", as(png) name("decomp") replace 

cap graph drop _all
}


/******************************************************************************/


{
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2.dta", clear

foreach q in "10" "20" "25" "30" "40" "50" "60" "70" "75" "80" "90" {
    bootstrap, r(100): oaxaca_rif lwr $hc $demo_dummy $occu_dummy $firm_conti_alter n(cmarr*) n(cjobt*) n(csize*) n(cy*) n(cind1-cind5) n(cprefecture*), by(soe) wgt(1) rif(q(`q')) swap relax
    if ("`q'"=="10") outreg2 using decomp_rif_alter_2, excel dec(3) ct("q(10)") replace
	else outreg2 using decomp_rif_alter_2, excel dec(3) ct("q(`q')") append 
	
    mat drop _all  
	mat b = e(b) 
	
	sca gap`q'_ffl_alter = b[1, 3]
	sca cha`q'_ffl_alter = b[1, 4]
	sca coe`q'_ffl_alter = b[1, 5]
	sca coeshare`q'_ffl_alter = coe`q'_ffl_alter/gap`q'_ffl_alter
	sca coeshare`q'str_ffl_alter = strofreal(coeshare`q'_ffl_alter*100, "%4.2f")+"%"
}

mat drop _all
mat result_ffl_alter = J(9, 3, 0)

forv i = 1/9 {
	loc q = `i'*10 
	
	mat result_ffl_alter[`i', 1] = gap`q'_ffl_alter 
	mat result_ffl_alter[`i', 2] = cha`q'_ffl_alter
	mat result_ffl_alter[`i', 3] = coe`q'_ffl_alter
}    

putexcel set decompresult_alter.xlsx, modify
putexcel E2 = matrix(result_ffl_alter), overwr 

{
tempfile table
tempname decomp_rif_share_alter

postfile `decomp_rif_share_alter' str200(share_q10 share_q20 share_q25 share_q30 share_q40 share_q50 share_q60 share_q70 share_q75 share_q80 share_q90) using `table', replace 

post `decomp_rif_share_alter' (coeshare10str_ffl_alter) (coeshare20str_ffl_alter) (coeshare25str_ffl_alter) (coeshare30str_ffl_alter) (coeshare40str_ffl_alter) (coeshare50str_ffl_alter) (coeshare60str_ffl_alter) (coeshare70str_ffl_alter) (coeshare75str_ffl_alter) (coeshare80str_ffl_alter) (coeshare90str_ffl_alter) 

postclose `decomp_rif_share_alter'
use `table', clear
export excel using decomp_rif_share_alter_2, replace firstrow(variables)
}
}


{
import exc using "C:\Personal\study\research\2022.04 wage gap\cdr\result\decompresult_alter.xlsx", clear first 

gr set window fontface "Times New Roman" 
gr set window fontfacesans "宋体"

foreach mthd in "MM" "FFL" {
	cap gr drop decomp_`mthd'
	
	tw (line gap_`mthd' q, lc(black) lp(solid)) ///
       (scatter gap_`mthd' q, mc(black) msym(oh)) ///
       (line cha_`mthd' q, lc(black) lp(dash)) /// 
       (scatter cha_`mthd' q, mc(black) msym(th)) ///
       (line coe_`mthd' q, lc(black) lp(shortdash_dot)) ///
       (scatter coe_`mthd' q, mc(black) msym(dh)), ///
       $graph_opts ///
       ylab(0(.2).6, labs(medsmall)) ///
       xlab(10(10)90, labs(medsmall)) /// 
       ti("{stSans:`mthd'分解}", nobox pos(12) si(medlarge)) ///
       yti("{stSans:工}""{stSans:资}""{stSans:差}""{stSans:异}", orientation(h) nobox place(9) si(med)) ///
       xti("{stSans:工资百分位}", nobox place(6) si(med)) /// 
       ysc(r(-.05(.05).6) line) ///
       xsc(line) ///
       legend(on order(2 4 6) label(2 "{stSans:工资总差异}") label(4 "{stSans:禀赋效应}") label(6 "{stSans:溢价效应}") symy(*.25) r(1) si(small) span) ///
       name(decomp_`mthd') 
}

cap graph drop decomp_alter
grc1leg decomp_MM decomp_FFL, ///
    r(1) ///
	graphregion(color(white)) ///
	leg(decomp_MM) pos(6) span /// 
	name(decomp_alter) 

gr save "decomp_alter" "C:\Personal\study\research\2022.04 wage gap\cdr\code\compare_decomp_alter_2.gph", replace
gr export "C:\Personal\study\research\2022.04 wage gap\cdr\result\comparation between MM & FFL_alter.png", as(png) name("decomp_alter") replace 

cap graph drop _all
}


/*----------------------------------------------------------------------------*/


/*salary*/
{
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_salary_2.dta", clear   

reg lsalary soe workinghm $hc $demo $occu $firm $fe, r
outreg2 using reg_sw_salary_2, excel dec(3) ct("ols") replace 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    capture: qreg lsalary soe workinghm $hc $demo $occu $firm $fe, q(`q') vce(r, ker(tri))
	outreg2 using reg_sw_salary_2, excel dec(3) ct("`q'") append
}
}


{
oaxaca9 lsalary workinghm $hc $demo_dummy $occu_dummy $firm_conti $firm_dummy, by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p 
outreg2 using decomp_ob_salary_2, excel dec(3) replace 

mat drop _all
mat b = e(b) 
sca gap_salary = b[1, 3]
sca coe_salary = b[1, 5] 
sca coeshare_salary = coe_salary/gap_salary
sca coesharestr_salary = strofreal(coeshare_salary*100, "%4.2f")+"%" 

tempfile table
tempname decomp_ob_salary_share

postfile `decomp_ob_salary_share' str200(share_salary) using `table', replace 

post `decomp_ob_salary_share' (coesharestr_salary) 

postclose `decomp_ob_salary_share'
use `table', clear
export excel using decomp_ob_salary_share_2, replace firstrow(variables)
}

	
{
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_salary_2.dta", clear

recode soe (0 = 1) (1 = 0), gen(nsoe) 
	    
cdeco lsalary workinghm $hc $demo $occu $firm $fe, g(nsoe) q(.1 .25 .5 .75 .9) 
outreg2 using decomp_qd_salary_2, excel dec(3) replace
	
mat drop _all
mat b = e(b) 
        
forv i = 1/5 {
    sca gap`i'_salary = b[1, `i']
    sca coe`i'_salary = b[1, 10+`i'] 
    sca coeshare`i'_salary = coe`i'_salary/gap`i'_salary
    sca coeshare`i'str_salary = strofreal(coeshare`i'_salary*100, "%4.2f")+"%" 
}

tempfile table
tempname decomp_qd_salary_share

postfile `decomp_qd_salary_share' str200(share_q10 share_q25 share_q50 share_q75 share_q90) using `table', replace 

post `decomp_qd_salary_share' (coeshare1str_salary) (coeshare2str_salary) (coeshare3str_salary) (coeshare4str_salary) (coeshare5str_salary) 

postclose `decomp_qd_salary_share'
use `table', clear
export excel using decomp_qd_salary_share_2, replace firstrow(variables)
}


/******************************************************************************/


{
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_salary_2.dta", clear   

reg lsalary soe workinghm $hc $demo $occu $firm_alter $fe_alter, r
outreg2 using reg_sw_salary_alter_2, excel dec(3) ct("ols-with wh") replace 

reg lsalary soe $hc $demo $occu $firm_alter $fe_alter, r
outreg2 using reg_sw_salary_alter_2, excel dec(3) ct("ols-without wh") append 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    capture: qreg lsalary soe workinghm $hc $demo $occu $firm_alter $fe_alter, q(`q') vce(r, ker(tri))
	outreg2 using reg_sw_salary_alter_2, excel dec(3) ct("`q'-with wh") append
    
	capture: qreg lsalary soe $hc $demo $occu $firm_alter $fe_alter, q(`q') vce(r, ker(tri))
	outreg2 using reg_sw_salary_alter_2, excel dec(3) ct("`q'-without wh") append
}
}


{
{
oaxaca9 lsalary workinghm $hc $demo_dummy $occu_dummy $firm_conti_alter, by(soe) swap cat(cmarr*, cjobt*, csize*, cy*, cind1-cind5, cprefecture*) p 
outreg2 using decomp_ob_salary_alter_2, excel dec(3) replace 

mat drop _all
mat b = e(b) 
sca gap_salary_alter_w = b[1, 3]
sca coe_salary_alter_w = b[1, 5] 
sca coeshare_salary_alter_w = coe_salary_alter_w/gap_salary_alter_w
sca coesharestr_salary_alter_w = strofreal(coeshare_salary_alter_w*100, "%4.2f")+"%" 
}

{
oaxaca9 lsalary $hc $demo_dummy $occu_dummy $firm_conti_alter, by(soe) swap cat(cmarr*, cjobt*, csize*, cy*, cind1-cind5, cprefecture*) p 
outreg2 using decomp_ob_salary_alter_2, excel dec(3) append 

mat drop _all
mat b = e(b) 
sca gap_salary_alter_wo = b[1, 3]
sca coe_salary_alter_wo = b[1, 5] 
sca coeshare_salary_alter_wo = coe_salary_alter_wo/gap_salary_alter_wo
sca coesharestr_salary_alter_wo = strofreal(coeshare_salary_alter_wo*100, "%4.2f")+"%"
}

tempfile table
tempname decomp_ob_salary_share_alter

postfile `decomp_ob_salary_share_alter' str200(share_salary) using `table', replace 

post `decomp_ob_salary_share_alter' (coesharestr_salary_alter_w) 
post `decomp_ob_salary_share_alter' (coesharestr_salary_alter_wo) 

postclose `decomp_ob_salary_share_alter'
use `table', clear
export excel using decomp_ob_salary_share_alter_2, replace firstrow(variables)
}

	
{
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_salary_2.dta", clear

recode soe (0 = 1) (1 = 0), gen(nsoe) 

{	    
cdeco lsalary workinghm $hc $demo $occu $firm_alter $fe_alter, g(nsoe) q(.1 .25 .5 .75 .9) 
outreg2 using decomp_qd_salary_alter_2, excel dec(3) replace
	
mat drop _all
mat b = e(b) 
        
forv i = 1/5 {
    sca gap`i'_salary_alter_w = b[1, `i']
    sca coe`i'_salary_alter_w = b[1, 10+`i'] 
    sca coeshare`i'_salary_alter_w = coe`i'_salary_alter_w/gap`i'_salary_alter_w
    sca coeshare`i'str_salary_alter_w = strofreal(coeshare`i'_salary_alter_w*100, "%4.2f")+"%" 
}
}

{
cdeco lsalary $hc $demo $occu $firm_alter $fe_alter, g(nsoe) q(.1 .25 .5 .75 .9) 
outreg2 using decomp_qd_salary_alter_2, excel dec(3) append 
	
mat drop _all
mat b = e(b) 
        
forv i = 1/5 {
    sca gap`i'_salary_alter_wo = b[1, `i']
    sca coe`i'_salary_alter_wo = b[1, 10+`i'] 
    sca coeshare`i'_salary_alter_wo = coe`i'_salary_alter_wo/gap`i'_salary_alter_wo
    sca coeshare`i'str_salary_alter_wo = strofreal(coeshare`i'_salary_alter_wo*100, "%4.2f")+"%" 
}
}

tempfile table
tempname decomp_qd_salary_share_alter

postfile `decomp_qd_salary_share_alter' str200(share_q10 share_q25 share_q50 share_q75 share_q90) using `table', replace 

post `decomp_qd_salary_share_alter' (coeshare1str_salary_alter_w) (coeshare2str_salary_alter_w) (coeshare3str_salary_alter_w) (coeshare4str_salary_alter_w) (coeshare5str_salary_alter_w) 
post `decomp_qd_salary_share_alter' (coeshare1str_salary_alter_wo) (coeshare2str_salary_alter_wo) (coeshare3str_salary_alter_wo) (coeshare4str_salary_alter_wo) (coeshare5str_salary_alter_wo) 

postclose `decomp_qd_salary_share_alter'
use `table', clear
export excel using decomp_qd_salary_share_alter_2, replace firstrow(variables)
}


/*----------------------------------------------------------------------------*/


/*hcp*/
/*
foreach hcp in "hcp1" "hcp2" "hcp3" {
	use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_`hcp'_0.dta", clear  

    reg lwr soe $fe, r 
    outreg2 using robust_sw_`hcp'_2, excel dec(3) ct("raw-ols") replace 

    foreach q in ".10" ".25" ".50" ".75" ".90" {
        qreg lwr soe $fe, q(`q') vce(r)
	    outreg2 using robust_sw_`hcp'_2, excel dec(3) ct("raw-`q'") append
    }

	
	use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_`hcp'_1.dta", clear

    reg lwr soe $`hcp' $fe, r 
    outreg2 using robust_sw_`hcp'_2, excel dec(3) ct("hc-ols") append 

    foreach q in ".10" ".25" ".50" ".75" ".90" {
        qreg lwr soe $`hcp' $fe, q(`q') vce(r)
	    outreg2 using robust_sw_`hcp'_2, excel dec(3) ct("hc-`q'") append
    }

	
	reg lwr soe $`hcp' $demo $fe, r 
    outreg2 using robust_sw_`hcp'_2, excel dec(3) ct("demo-ols") append

    foreach q in ".10" ".25" ".50" ".75" ".90" {
        qreg lwr soe $`hcp' $demo $fe, q(`q') vce(r)
	    outreg2 using robust_sw_`hcp'_2, excel dec(3) ct("demo-`q'") append
    }

	
	reg lwr soe $`hcp' $demo $occu $fe, r 
    outreg2 using robust_sw_`hcp'_2, excel dec(3) ct("occu-ols") append 

    foreach q in ".10" ".25" ".50" ".75" ".90" {
        qreg lwr soe $`hcp' $demo $occu $fe, q(`q') vce(r) 
        outreg2 using robust_sw_`hcp'_2, excel dec(3) ct("occu-`q'") append
    }
	
	
	use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_`hcp'_2.dta", clear  

    reg lwr soe $`hcp' $demo $occu lrevenue $fe, r 
    outreg2 using robust_sw_`hcp'_2, excel dec(3) ct("lrevenue-ols") append 

    foreach q in ".10" ".25" ".50" ".75" ".90" {
        qreg lwr soe $`hcp' $demo $occu lrevenue $fe, q(`q') vce(r)
	    outreg2 using robust_sw_`hcp'_2, excel dec(3) ct("lrevenue-`q'") append
    }

	
	reg lwr soe $`hcp' $demo $occu $firm $fe, r 
    outreg2 using robust_sw_`hcp'_2, excel dec(3) ct("firm_other-ols") append 


    foreach q in ".10" ".25" ".50" ".75" ".90" {
        qreg lwr soe $`hcp' $demo $occu $firm $fe, q(`q') vce(r)
	    outreg2 using robust_sw_`hcp'_2, excel dec(3) ct("firm_other-`q'") append
    }
}


foreach hcp in "hcp1" "hcp2" "hcp3" {
    use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_`hcp'_2.dta", clear    
	    
    if ("`hcp'"=="hcp1") oaxaca9 lwr $`hcp' $demo_dummy $occu_dummy $firm_conti, by(soe) swap cat(cmarr*, cjobt*, csize*, cy*, cind1-cind5, cprefecture*) p 
	else if ("`hcp'"=="hcp2") oaxaca9 lwr $maexp $hc_dummy $demo_dummy $occu_dummy $firm_conti, by(soe) swap cat(cedul1-cedul5, cmarr*, cjobt*, csize*, cy*, cind1-cind5, cprefecture*) p
	else oaxaca9 lwr $matenure $hc_dummy $demo_dummy $occu_dummy $firm_conti, by(soe) swap cat(cedul1-cedul5, cmarr*, cjobt*, csize*, cy*, cind1-cind5, cprefecture*) p
		
    mat drop _all
    mat b = e(b) 
    sca gap = b[1, 3]
    sca coe = b[1, 5] 
    sca coeshare = coe/gap
    sca coesharestr = strofreal(coeshare*100, "%4.2f")+"%" 
	
    outreg2 using robust_ob_`hcp'_2, excel dec(3) replace

    tempfile table
    tempname robust_ob_`hcp'_share

    postfile `robust_ob_`hcp'_share' str200(share) using `table', replace 

    post `robust_ob_`hcp'_share' (coesharestr) 

    postclose `robust_ob_`hcp'_share'
    use `table', clear
    export excel using robust_ob_`hcp'_share_2, replace firstrow(variables)
}


foreach hcp in "hcp1" "hcp2" "hcp3" {
    use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_`hcp'_2.dta", clear
	
    recode soe (0 = 1) (1 = 0), gen(nsoe) 
	    
    cdeco lwr $`hcp' $demo $occu $firm $fey $feind $feprefecture, g(nsoe) q(.1 .25 .5 .75 .9) 
	
    mat drop _all
    mat b = e(b) 
        
    forv i = 1/5 {
        sca gap`i' = b[1, `i']
        sca coe`i' = b[1, 10+`i'] 
        sca coeshare`i' = coe`i'/gap`i'
        sca coeshare`i'str = strofreal(coeshare`i'*100, "%4.2f")+"%" 
    }
	
    outreg2 using robust_qd_`hcp'_2, excel dec(3) replace

    tempfile table
    tempname robust_qd_`hcp'_share

    postfile `robust_qd_`hcp'_share' str200(Q(10) Q(25) Q(50) Q(75) Q(90)) using `table', replace 

    post `robust_qd_`hcp'_share' (coeshare1str) (coeshare2str) (coeshare3str) (coeshare4str) (coeshare5str)  
    
    postclose `robust_qd_`hcp'_share'
    use `table', clear
    export excel using robust_qd_`hcp'_share_2, replace firstrow(variables)
}
*/


{
foreach hcp in "hcp1" "hcp2" "hcp3" {
	use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_`hcp'_2.dta", clear 
	
	reg lwr soe $hcp1 $demo $occu $firm $fe, r 
    if ("`hcp'"=="hcp1") outreg2 using reg_sw_hcp_2, excel dec(3) ct("`hcp'-ols") replace 
	else outreg2 using reg_sw_hcp_2, excel dec(3) ct("`hcp'-ols") append 
		
    foreach q in ".10" ".25" ".50" ".75" ".90" {
	    capture: qreg lwr soe $`hcp' $demo $occu $firm $fe, q(`q') vce(r, ker(tri))
        outreg2 using reg_sw_hcp_2, excel dec(3) ct("`hcp'-`q'") append 
    }
}
}


{
foreach hcp in "hcp1" "hcp2" "hcp3" {
    use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_`hcp'_2.dta", clear    
	
    if ("`hcp'"=="hcp1") oaxaca9 lwr $hcp1 $demo_dummy $occu_dummy $firm_conti $firm_dummy, by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p 
	else if ("`hcp'"=="hcp2") oaxaca9 lwr $maexp $hc_dummy $demo_dummy $occu_dummy $firm_conti $firm_dummy, by(soe) swap cat(cedul1-cedul5, cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p
	else oaxaca9 lwr $matenure $hc_dummy $demo_dummy $occu_dummy $firm_conti $firm_dummy, by(soe) swap cat(cedul1-cedul5, cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p
		
    mat drop _all
    mat b = e(b) 
    sca gap_`hcp' = b[1, 3]
    sca coe_`hcp' = b[1, 5] 
    sca coeshare_`hcp' = coe_`hcp'/gap_`hcp'
    sca coesharestr_`hcp' = strofreal(coeshare_`hcp'*100, "%4.2f")+"%" 
	
    if ("`hcp'"=="hcp1") outreg2 using decomp_ob_hcp_2, excel dec(3) replace 
	else outreg2 using decomp_ob_hcp_2, excel dec(3) append
}

tempfile table
tempname decomp_ob_hcp_share

postfile `decomp_ob_hcp_share' str200(share_hcp1 share_hcp2 share_hcp3) using `table', replace 

post `decomp_ob_hcp_share' (coesharestr_hcp1) (coesharestr_hcp2) (coesharestr_hcp3) 

postclose `decomp_ob_hcp_share'
use `table', clear
export excel using decomp_ob_hcp_share_2, replace firstrow(variables)
}


{
foreach hcp in "hcp1" "hcp2" "hcp3" {
    use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_`hcp'_2.dta", clear
	
    recode soe (0 = 1) (1 = 0), gen(nsoe) 
	
    cdeco lwr $`hcp' $demo $occu $firm $fe, g(nsoe) q(.1 .25 .5 .75 .9) 
	
    mat drop _all
    mat b = e(b) 
        
    forv i = 1/5 {
        sca gap`i'_`hcp' = b[1, `i']
        sca coe`i'_`hcp' = b[1, 10+`i'] 
        sca coeshare`i'_`hcp' = coe`i'_`hcp'/gap`i'_`hcp'
        sca coeshare`i'str_`hcp' = strofreal(coeshare`i'_`hcp'*100, "%4.2f")+"%" 
    }
	
    if ("`hcp'"=="hcp1") outreg2 using decomp_qd_hcp_2, excel dec(3) replace 
	else outreg2 using decomp_qd_hcp_2, excel dec(3) append 
}

tempfile table
tempname decomp_qd_hcp_share

postfile `decomp_qd_hcp_share' str200(share_q10 share_q25 share_q50 share_q75 share_q90) using `table', replace 

post `decomp_qd_hcp_share' (coeshare1str_hcp1) (coeshare2str_hcp1) (coeshare3str_hcp1) (coeshare4str_hcp1) (coeshare5str_hcp1) 
post `decomp_qd_hcp_share' (coeshare1str_hcp2) (coeshare2str_hcp2) (coeshare3str_hcp2) (coeshare4str_hcp2) (coeshare5str_hcp2) 
post `decomp_qd_hcp_share' (coeshare1str_hcp3) (coeshare2str_hcp3) (coeshare3str_hcp3) (coeshare4str_hcp3) (coeshare5str_hcp3)
    
postclose `decomp_qd_hcp_share'
use `table', clear
export excel using decomp_qd_hcp_share_2, replace firstrow(variables)
}


/*----------------------------------------------------------------------------*/


/*2021-*/
/*
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2021__0.dta", clear 

reg lwr soe $fe, r 
outreg2 using robust_sw_2021__2, excel dec(3) ct("raw-ols") replace 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    qreg lwr soe $fe, q(`q') vce(r)
	outreg2 using robust_sw_2021__2, excel dec(3) ct("raw-`q'") append
}


use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2021__1.dta", clear

reg lwr soe $hc $fe, r 
outreg2 using robust_sw_2021__2, excel dec(3) ct("hc-ols") append 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    qreg lwr soe $hc $fe, q(`q') vce(r)
	outreg2 using robust_sw_2021__2, excel dec(3) ct("hc-`q'") append
}

reg lwr soe $hc $demo $fe, r 
outreg2 using robust_sw_2021__2, excel dec(3) ct("demo-ols") append

foreach q in ".10" ".25" ".50" ".75" ".90" {
    qreg lwr soe $hc $demo $fe, q(`q') vce(r)
	outreg2 using robust_sw_2021__2, excel dec(3) ct("demo-`q'") append
}

reg lwr soe $hc $demo $occu $fe, r 
outreg2 using robust_sw_2021__2, excel dec(3) ct("occu-ols") append 

foreach q in ".10" ".25" ".50" ".75" ".90" {
   qreg lwr soe $hc $demo $occu $fe, q(`q') vce(r) 
   outreg2 using robust_sw_2021__2, excel dec(3) ct("occu-`q'") append
}


use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2021__2.dta", clear  

reg lwr soe $hc $demo $occu lrevenue $fe, r 
outreg2 using robust_sw_2021__2, excel dec(3) ct("lrevenue-ols") append 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    qreg lwr soe $hc $demo $occu lrevenue $fe, q(`q') vce(r)
	outreg2 using robust_sw_2021__2, excel dec(3) ct("lrevenue-`q'") append
}

reg lwr soe $hc $demo $occu $firm $fe, r 
outreg2 using robust_sw_2021__2, excel dec(3) ct("firm_other-ols") append 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    qreg lwr soe $hc $demo $occu $firm $fe, q(`q') vce(r)
	outreg2 using robust_sw_2021__2, excel dec(3) ct("firm_other-`q'") append
}
*/


{
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2021__2.dta", clear   
reg lwr soe $hc $demo $occu $firm $fe, r
outreg2 using reg_sw_2021__2, excel dec(3) ct("ols") replace 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    capture: qreg lwr soe $hc $demo $occu $firm $fe, q(`q') vce(r, ker(tri))
	outreg2 using reg_sw_2021__2, excel dec(3) ct("`q'") append
}
}


{
oaxaca9 lwr $hc $demo_dummy $occu_dummy $firm_conti $firm_dummy, by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p 
outreg2 using decomp_ob_2021__2, excel dec(3) replace 

mat drop _all
mat b = e(b) 
sca gap_2021_ = b[1, 3]
sca coe_2021_ = b[1, 5] 
sca coeshare_2021_ = coe_2021_/gap_2021_
sca coesharestr_2021_ = strofreal(coeshare_2021_*100, "%4.2f")+"%" 

tempfile table
tempname decomp_ob_2021__share

postfile `decomp_ob_2021__share' str200(share_2021_) using `table', replace 

post `decomp_ob_2021__share' (coesharestr_2021_) 

postclose `decomp_ob_2021__share'
use `table', clear
export excel using decomp_ob_2021__share_2, replace firstrow(variables)
}

	
{
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2021__2.dta", clear

recode soe (0 = 1) (1 = 0), gen(nsoe) 
	    
cdeco lwr $hc $demo $occu $firm $fe, g(nsoe) q(.1 .25 .5 .75 .9) 
outreg2 using decomp_qd_2021__2, excel dec(3) replace
	
mat drop _all
mat b = e(b) 
        
forv i = 1/5 {
    sca gap`i'_2021_ = b[1, `i']
    sca coe`i'_2021_ = b[1, 10+`i'] 
    sca coeshare`i'_2021_ = coe`i'_2021_/gap`i'_2021_
    sca coeshare`i'str_2021_ = strofreal(coeshare`i'_2021_*100, "%4.2f")+"%" 
}

tempfile table
tempname decomp_qd_2021__share

postfile `decomp_qd_2021__share' str200(share_q10 share_q25 share_q50 share_q75 share_q90) using `table', replace 

post `decomp_qd_2021__share' (coeshare1str_2021_) (coeshare2str_2021_) (coeshare3str_2021_) (coeshare4str_2021_) (coeshare5str_2021_) 

postclose `decomp_qd_2021__share'
use `table', clear
export excel using decomp_qd_2021__share_2, replace firstrow(variables)
}



/*============================================================================*/



//mechanism
/*gen hetero.dta*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_2.dta", clear 

{
_pctile lwr, p(50) 
sca mid = `r(r1)'

gen wl = 1 
replace wl = 2 if (lwr>=mid) 
}

{
_pctile lwr, p(33.33 66.67) 
sca low = `r(r1)'
sca high = `r(r2)' 

gen wlp = 1 
replace wlp = 2 if (lwr>=low) & (lwr<high) 
replace wlp = 3 if (lwr>=high)
}

{
gen wlpp = 1 
replace wlpp = 2 if (lwr>=low) 
}


save "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", replace


/*summary statistics mecha*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear

foreach x in "socialsip" "mwelfareip" "nwelfareip" ///
             "safec" "healtht" "relationp" {
	forv i = 0/1 {
	    qui sum `x' if (soe==`i') 
		if ("`x'"!="socialsip") | ("`x'"!="mwelfareip") | ("`x'"!="nwelfareip") {
		    loc m`x'`i' = string(100*r(mean), "%4.2f") 
		}
		else loc m`x'`i' = string(r(mean), "%4.3f")
	    loc sd`x'`i' = string(r(sd), "%4.3f")
		loc N`x'`i' = string(r(N), "%4.0f")
		
		forv j = 1/2 {
	        qui sum `x' if (soe==`i') & (wl==`j')
	        if ("`x'"!="socialsip") | ("`x'"!="mwelfareip") | ("`x'"!="nwelfareip") {
			   loc m`x'`i'`j'_wl = string(100*r(mean), "%4.2f") 
			}
			else loc m`x'`i'`j'_wl = string(r(mean), "%4.3f")
	        loc sd`x'`i'`j'_wl = string(r(sd), "%4.3f")   
			loc N`x'`i'`j'_wl = string(r(N), "%4.0f")
	    }
    
	    forv k = 1/3 {
			qui sum `x' if (soe==`i') & (wlp==`k')
	        if ("`x'"!="socialsip") | ("`x'"!="mwelfareip") | ("`x'"!="nwelfareip") {
			   loc m`x'`i'`k'_wlp = string(100*r(mean), "%4.2f") 
			}
			else loc m`x'`i'`k'_wlp = string(r(mean), "%4.3f")
	        loc sd`x'`i'`k'_wlp = string(r(sd), "%4.3f")   
			loc N`x'`i'`k'_wlp = string(r(N), "%4.0f")
		}
	
		forv l = 1/2 {
	        qui sum `x' if (soe==`i') & (wlpp==`l')
	        if ("`x'"!="socialsip") | ("`x'"!="mwelfareip") | ("`x'"!="nwelfareip") {
			   loc m`x'`i'`l'_wlpp = string(100*r(mean), "%4.2f") 
			}
			else loc m`x'`i'`l'_wlpp = string(r(mean), "%4.3f")
	        loc sd`x'`i'`l'_wlpp = string(r(sd), "%4.3f")   
			loc N`x'`i'`l'_wlpp = string(r(N), "%4.0f")
	    }	    
	}
}

{
tempfile table
tempname dtades_mecha

postfile `dtades_mecha' str200(Varname Mean_Soe Mean_Nsoe Mean_Soe_Low Mean_Nsoe_Low Mean_Soe_High Mean_Nsoe_High) using `table', replace 
foreach x in "socialsip" "mwelfareip" "nwelfareip" ///
             "safec" "healtht" "relationp" {
    post `dtades_mecha' ("`x'") ("`m`x'1'") ("`m`x'0'") ("`m`x'11_wl'") ("`m`x'01_wl'") ("`m`x'12_wl'") ("`m`x'02_wl'")  
	post `dtades_mecha' ("") ("(`sd`x'1')") ("(`sd`x'0')") ("(`sd`x'11_wl')") ("(`sd`x'01_wl')") ("(`sd`x'12_wl')") ("(`sd`x'02_wl')")
	post `dtades_mecha' ("") ("`N`x'1'") ("`N`x'0'") ("`N`x'11_wl'") ("`N`x'01_wl'") ("`N`x'12_wl'") ("`N`x'02_wl'")
}
					   
postclose `dtades_mecha'

use `table', clear
export excel using dtades_mecha_2, replace firstrow(variables)
}

{
tempfile table
tempname dtades_mechap

postfile `dtades_mechap' str200(Varname Mean_Soe Mean_Nsoe Mean_Soe_Low Mean_Nsoe_Low Mean_Soe_Mid Mean_Nsoe_Mid Mean_Soe_High Mean_Nsoe_High) using `table', replace 
foreach x in "socialsip" "mwelfareip" "nwelfareip" ///
             "safec" "healtht" "relationp" {
    post `dtades_mechap' ("`x'") ("`m`x'1'") ("`m`x'0'") ("`m`x'11_wlp'") ("`m`x'01_wlp'") ("`m`x'12_wlp'") ("`m`x'02_wlp'") ("`m`x'13_wlp'") ("`m`x'03_wlp'")  
	post `dtades_mechap' ("") ("(`sd`x'1')") ("(`sd`x'0')") ("(`sd`x'11_wlp')") ("(`sd`x'01_wlp')") ("(`sd`x'12_wlp')") ("(`sd`x'02_wlp')") ("(`sd`x'13_wlp')") ("(`sd`x'03_wlp')")
	post `dtades_mechap' ("") ("`N`x'1'") ("`N`x'0'") ("`N`x'11_wlp'") ("`N`x'01_wlp'") ("`N`x'12_wlp'") ("`N`x'02_wlp'") ("`N`x'13_wlp'") ("`N`x'03_wlp'") 
}
					   
postclose `dtades_mechap'

use `table', clear
export excel using dtades_mechap_2, replace firstrow(variables)
}

{
tempfile table
tempname dtades_mechapp

postfile `dtades_mechapp' str200(Varname Mean_Soe Mean_Nsoe Mean_Soe_Low Mean_Nsoe_Low Mean_Soe_NoLow Mean_Nsoe_NoLow) using `table', replace 
foreach x in "socialsip" "mwelfareip" "nwelfareip" ///
             "safec" "healtht" "relationp" {
    post `dtades_mechapp' ("`x'") ("`m`x'1'") ("`m`x'0'") ("`m`x'11_wlpp'") ("`m`x'01_wlpp'") ("`m`x'12_wlpp'") ("`m`x'02_wlpp'")  
	post `dtades_mechapp' ("") ("(`sd`x'1')") ("(`sd`x'0')") ("(`sd`x'11_wlpp')") ("(`sd`x'01_wlpp')") ("(`sd`x'12_wlpp')") ("(`sd`x'02_wlpp')")
	post `dtades_mechapp' ("") ("`N`x'1'") ("`N`x'0'") ("`N`x'11_wlpp'") ("`N`x'01_wlpp'") ("`N`x'12_wlpp'") ("`N`x'02_wlpp'")
}
					   
postclose `dtades_mechapp'

use `table', clear
export excel using dtades_mechapp_2, replace firstrow(variables)
}


/*change dependent*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear

foreach x in "socialsip" "mwelfareip" "nwelfareip" {
    reg `x' soe $hc $demo $occu $firm $fe, r
	
	if ("`x'"=="socialsip") {
		outreg2 using reg_yalter_wl_2, excel dec(3) ct("socialsip-0") replace
		outreg2 using reg_yalter_wlp_2, excel dec(3) ct("socialsip-0-wlp") replace 
		outreg2 using reg_yalter_wlpp_2, excel dec(3) ct("socialsip-0-wlpp") replace
	}
	else {
		outreg2 using reg_yalter_wl_2, excel dec(3) ct("`x'-0") append 
	    outreg2 using reg_yalter_wlp_2, excel dec(3) ct("`x'-0-wlp") append
	    outreg2 using reg_yalter_wlpp_2, excel dec(3) ct("`x'-0-wlpp") append
	}
	
	forv i = 1/2 {
        reg `x' soe $hc $demo $occu $firm $fe if (wl==`i'), r 
        outreg2 using reg_yalter_wl_2, excel dec(3) ct("`x'-`i'") append
    }
    
	forv j = 1/3 {
        reg `x' soe $hc $demo $occu $firm $fe if (wlp==`j'), r 
        outreg2 using reg_yalter_wlp_2, excel dec(3) ct("`x'-`j'-wlp") append
    }
    
	forv k = 1/2 {
        reg `x' soe $hc $demo $occu $firm $fe if (wlpp==`k'), r 
        outreg2 using reg_yalter_wlpp_2, excel dec(3) ct("`x'-`k'-wlpp") append
    }
}

foreach x in "safec" "healtht" "relationp" {
    probit `x' soe $hc $demo $occu $firm $fe, vce(r) 
    margins, dydx(soe) atmeans post 
	outreg2 using reg_yalter_wl_2, excel dec(3) ct("`x'-0") append 
	outreg2 using reg_yalter_wlp_2, excel dec(3) ct("`x'-0-wlp") append 
	outreg2 using reg_yalter_wlpp_2, excel dec(3) ct("`x'-0-wlpp") append 
		
	forv i = 1/2 {
        probit `x' soe $hc $demo $occu $firm $fe if (wl==`i'), vce(r) 
        margins, dydx(soe) atmeans post
        outreg2 using reg_yalter_wl_2, excel dec(3) ct("`x'-`i'") append
    }
    
	forv j = 1/3 {
        probit `x' soe $hc $demo $occu $firm $fe if (wlp==`j'), vce(r) 
        margins, dydx(soe) atmeans post
        outreg2 using reg_yalter_wlp_2, excel dec(3) ct("`x'-`j'-wlp") append
    }

    forv k = 1/2 {
        probit `x' soe $hc $demo $occu $firm $fe if (wlpp==`k'), vce(r) 
        margins, dydx(soe) atmeans post
        outreg2 using reg_yalter_wlpp_2, excel dec(3) ct("`x'-`k'-wlpp") append
    }	
}


/*mobility matrix*/
mat drop _all

forv j = 0/1  {
    tab firmpast if (soe==`j'), matcell(firmpast_`j')
	forv i = 1/3 {
	    sca firmpast`i'_`j'_n = firmpast_`j'[`i', 1]
	}
}
forv j = 0/1 {
    forv i = 1/3 {
	    sca firmpast`i'_`j'_s = firmpast`i'_`j'_n/(firmpast1_`j'_n+firmpast2_`j'_n+firmpast3_`j'_n)
		sca firmpast`i'_`j'_sstr = strofreal(firmpast`i'_`j'_s*100, "%4.2f")
	}
}

tempfile table
tempname mecha_mm

postfile `mecha_mm' str60(indicator) str200(Nsoe_Perc Soe_Perc) using `table', replace 
forv i = 1/3 {
    post `mecha_mm' ("`i'") (firmpast`i'_0_sstr) (firmpast`i'_1_sstr) 
}

postclose `mecha_mm'

use `table', clear
export excel using mecha_mm_2, replace firstrow(variables)


/*lrv_capita*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\rawdata.dta", clear

{
reg lrv_capita soe $firm $fe, r
outreg2 using reg_sw_rvcapita_2, excel dec(3) ct("ols") replace 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    capture: qreg lrv_capita soe $firm $fe, q(`q') vce(r, ker(tri))
	outreg2 using reg_sw_rvcapita_2, excel dec(3) ct("`q'") append
}
}


{
oaxaca9 lrv_capita $firm_conti $firm_dummy, by(soe) swap cat(csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p 
outreg2 using decomp_ob_rvcapita_2, excel dec(3) replace 

mat drop _all
mat b = e(b) 
sca gap_rvcapita = b[1, 3]
sca coe_rvcapita = b[1, 5] 
sca coeshare_rvcapita = coe_rvcapita/gap_rvcapita
sca coesharestr_rvcapita = strofreal(coeshare_rvcapita*100, "%4.2f")+"%" 

tempfile table
tempname decomp_ob_rvcapita_share

postfile `decomp_ob_rvcapita_share' str200(share_rvcapita) using `table', replace 

post `decomp_ob_rvcapita_share' (coesharestr_rvcapita) 

postclose `decomp_ob_rvcapita_share'
use `table', clear
export excel using decomp_ob_rvcapita_share_2, replace firstrow(variables)
}

	
{
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\rawdata.dta", clear

recode soe (0 = 1) (1 = 0), gen(nsoe) 
	    
cdeco lrv_capita $firm $fe, g(nsoe) q(.1 .25 .5 .75 .9) 
outreg2 using decomp_qd_rvcapita_2, excel dec(3) replace
	
mat drop _all
mat b = e(b) 
        
forv i = 1/5 {
    sca gap`i'_rvcapita = b[1, `i']
    sca coe`i'_rvcapita = b[1, 10+`i'] 
    sca coeshare`i'_rvcapita = coe`i'_rvcapita/gap`i'_rvcapita
    sca coeshare`i'str_rvcapita = strofreal(coeshare`i'_rvcapita*100, "%4.2f")+"%" 
}

tempfile table
tempname decomp_qd_rvcapita_share

postfile `decomp_qd_rvcapita_share' str200(share_q10 share_q25 share_q50 share_q75 share_q90) using `table', replace 

post `decomp_qd_rvcapita_share' (coeshare1str_rvcapita) (coeshare2str_rvcapita) (coeshare3str_rvcapita) (coeshare4str_rvcapita) (coeshare5str_rvcapita) 

postclose `decomp_qd_rvcapita_share'
use `table', clear
export excel using decomp_qd_rvcapita_share_2, replace firstrow(variables)
}


/******************************************************************************/


use "C:\Personal\study\research\2022.04 wage gap\cdr\data\rawdata.dta", clear

reg lrv_capita soe $firm_alter $fe_alter, r
outreg2 using reg_sw_rvcapita_alter_2, excel dec(3) ct("ols") replace 

foreach q in ".10" ".25" ".50" ".75" ".90" {
    capture: qreg lrv_capita soe $firm_alter $fe_alter, q(`q') vce(r, ker(tri))
	outreg2 using reg_sw_rvcapita_alter_2, excel dec(3) ct("`q'") append
}



/*============================================================================*/



//heterogeneity
/*
/*year*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear 

loc y1 "2017年"
loc y2 "2019年"
loc y3 "2021年"

loc yaxis_y_2 ylab(, notick labc(white) labs(medium)) yti("") ysc(noline)
loc yaxis_y_3 ylab(, notick labc(white) labs(medium)) yti("") ysc(noline)

forv i = 1/3 {
    use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear 
		
	oaxaca9 lwr $hc $demo_dummy $occu_dummy $firm_conti if (y==`i'), by(soe) swap cat(cmarr*, cjobt*, csize*, cind1-cind5, cprefecture*) p    
    	
	mat drop _all
	///coe
	mat b_`i'0 = e(b) 
    sca b_gap_`i'0 = b_`i'0[1, 3] 
    sca b_cha_`i'0 = b_`i'0[1, 4] 
    sca b_coe_`i'0 = b_`i'0[1, 5] 
    ///ci
	mat v_`i'0 = e(V)
    sca v_gap_`i'0 = v_`i'0[3, 3]
    sca v_cha_`i'0 = v_`i'0[4, 4] 
    sca v_coe_`i'0 = v_`i'0[5, 5] 
    sca ll_gap_`i'0 = b_gap_`i'0-1.96*sqrt(v_gap_`i'0) 
    sca ul_gap_`i'0 = b_gap_`i'0+1.96*sqrt(v_gap_`i'0)
    sca ll_cha_`i'0 = b_cha_`i'0-1.96*sqrt(v_cha_`i'0)
    sca ul_cha_`i'0 = b_cha_`i'0+1.96*sqrt(v_cha_`i'0)
    sca ll_coe_`i'0 = b_coe_`i'0-1.96*sqrt(v_coe_`i'0) 
    sca ul_coe_`i'0 = b_coe_`i'0+1.96*sqrt(v_coe_`i'0) 
    ///result matrix 
    mat result_0_gap = [b_gap_`i'0, ll_gap_`i'0, ul_gap_`i'0, 0] 
    mat result_0_cha = [b_cha_`i'0, ll_cha_`i'0, ul_cha_`i'0, 0]
    mat result_0_coe = [b_coe_`i'0, ll_coe_`i'0, ul_coe_`i'0, 0]
		
	if (`i'==1) outreg2 using hetero_y_2, excel dec(3) ct("1-0") replace 
	else outreg2 using hetero_y_2, excel dec(3) ct("`i'-0") append 
		
	forv j = 1/2 {
	    oaxaca9 lwr $hc $demo_dummy $occu_dummy $firm_conti if (y==`i') & (wl==`j'), by(soe) swap cat(cmarr*, cjobt*, csize*, cind1-cind5, cprefecture*) p 
	    
		///coe
		mat b_`i'`j' = e(b) 
		sca b_gap_`i'`j' = b_`i'`j'[1, 3]
		sca b_cha_`i'`j' = b_`i'`j'[1, 4]
	    sca b_coe_`i'`j' = b_`i'`j'[1, 5] 
		///ci
		mat v_`i'`j' = e(V)
        sca v_gap_`i'`j' = v_`i'`j'[3, 3]
        sca v_cha_`i'`j' = v_`i'`j'[4, 4] 
        sca v_coe_`i'`j' = v_`i'`j'[5, 5] 
        sca ll_gap_`i'`j' = b_gap_`i'`j'-1.96*sqrt(v_gap_`i'`j') 
        sca ul_gap_`i'`j' = b_gap_`i'`j'+1.96*sqrt(v_gap_`i'`j')
        sca ll_cha_`i'`j' = b_cha_`i'`j'-1.96*sqrt(v_cha_`i'`j')
        sca ul_cha_`i'`j' = b_cha_`i'`j'+1.96*sqrt(v_cha_`i'`j')
        sca ll_coe_`i'`j' = b_coe_`i'`j'-1.96*sqrt(v_coe_`i'`j') 
        sca ul_coe_`i'`j' = b_coe_`i'`j'+1.96*sqrt(v_coe_`i'`j') 
        ///result matrix
        mat result_`j'_gap = [b_gap_`i'`j', ll_gap_`i'`j', ul_gap_`i'`j', `j'] 
        mat result_`j'_cha = [b_cha_`i'`j', ll_cha_`i'`j', ul_cha_`i'`j', `j']
        mat result_`j'_coe = [b_coe_`i'`j', ll_coe_`i'`j', ul_coe_`i'`j', `j']
				
		outreg2 using hetero_y_2, excel dec(3) ct("`i'-`j'") append
	}
    	
	foreach x in "gap" "cha" "coe" {
        forv j = 0/2 {
	        mat results = nullmat(results) \ result_`j'_`x'
	    }
    }
	
    mat colnames results = "b" "ll" "ul" "type" 
    
    clear
    svmat results , names(col)

	gen n = _n 

    ///graph    
	cap graph drop y`i'
		
	tw (rcap ul ll n if (type==0), lp(solid)) ///
        (scatter b n if (type==0), mc(black) msym(oh)) ///
        (rcap ul ll n if (type==1), lp(dash)) ///
        (scatter b n if (type==1), mc(black) msym(dh)) ///
	    (rcap ul ll n if (type==2), lp(shortdash_dot)) ///
        (scatter b n if (type==2), mc(black) msym(th)), ///
        $graph_opts ///
		ylab(-.2(.1).5, labs(medsmall)) ///
		xlab(2 "工资差距" 5 "禀赋效应" 8 "溢价效应", notick labs(small)) /// 
	    ti(`y`i'', nobox pos(12) si(medium)) ///
		yti("差值", nobox place(9) si(medium)) ///
		xti("") ///
		ysc(r(-.25(.05).55) line) ///
		xsc(r(0(1)10) line) ///
	    yline(0, lc(gs12) lp(dash)) ///
		legend(off order(2 4 6) label(2 "全样本") label(4 "低工资子样本") label(6 "高工资子样本") symy(*.25) r(1) si(small) span) ///
		`yaxis_y_`i'' ///
        name(y`i')
}

cap graph drop Graph 
grc1leg y1 y2 y3, ///
    row(1) ///
	graphregion(color(white)) /// 
	leg(y1) pos(6) span 
gr save "Graph" "C:\Personal\study\research\2022.04 wage gap\cdr\code\hetero_y_2.gph", replace
gr export "C:\Personal\study\research\2022.04 wage gap\cdr\result\heterogeneity analysis-year.png", as(png) name("Graph") replace

cap graph drop _all
*/


/*----------------------------------------------------------------------------*/


/*prefecture*/ 
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear 

loc prefecture1 "北京"
loc prefecture2 "上海"
loc prefecture3 "广州" 
loc prefecture4 "沈阳"
loc prefecture5 "西安"
loc prefecture6 "成都"

loc yaxis_prefecture_2 ylab(, notick labc(white) labs(medium)) yti("") ysc(noline)
loc yaxis_prefecture_3 ylab(, notick labc(white) labs(medium)) yti("") ysc(noline)
loc yaxis_prefecture_5 ylab(, notick labc(white) labs(medium)) yti("") ysc(noline)
loc yaxis_prefecture_6 ylab(, notick labc(white) labs(medium)) yti("") ysc(noline)

forv i = 1/6 {
    use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear 
		
	oaxaca9 lwr $hc $demo_dummy $occu_dummy $firm_conti $firm_dummy if (prefecture==`i'), by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cp?_y?) p     
    if (`i'==1) outreg2 using decomp_ob_prefecture_2, excel dec(3) ct("1") replace 
	else outreg2 using decomp_ob_prefecture_2, excel dec(3) ct("`i'") append 
	
	mat drop _all
	///coe	
    mat b_`i'0 = e(b) 
    sca b_gap_`i'0 = b_`i'0[1, 3] 
    sca b_cha_`i'0 = b_`i'0[1, 4] 
    sca b_coe_`i'0 = b_`i'0[1, 5] 
	///ci 
	mat v_`i'0 = e(V)
    sca v_gap_`i'0 = v_`i'0[3, 3]
    sca v_cha_`i'0 = v_`i'0[4, 4] 
    sca v_coe_`i'0 = v_`i'0[5, 5] 
    sca ll_gap_`i'0 = b_gap_`i'0-1.96*sqrt(v_gap_`i'0) 
    sca ul_gap_`i'0 = b_gap_`i'0+1.96*sqrt(v_gap_`i'0)
    sca ll_cha_`i'0 = b_cha_`i'0-1.96*sqrt(v_cha_`i'0)
    sca ul_cha_`i'0 = b_cha_`i'0+1.96*sqrt(v_cha_`i'0)
    sca ll_coe_`i'0 = b_coe_`i'0-1.96*sqrt(v_coe_`i'0) 
    sca ul_coe_`i'0 = b_coe_`i'0+1.96*sqrt(v_coe_`i'0) 
    ///result matrix 
    mat result_0_gap = [b_gap_`i'0, ll_gap_`i'0, ul_gap_`i'0, 0] 
    mat result_0_cha = [b_cha_`i'0, ll_cha_`i'0, ul_cha_`i'0, 0]
    mat result_0_coe = [b_coe_`i'0, ll_coe_`i'0, ul_coe_`i'0, 0]
		
	foreach x in "gap" "cha" "coe" {
	    mat results = nullmat(results) \ result_0_`x'
	}
	
    mat colnames results = "b" "ll" "ul" "type" 
        
    clear
    svmat results, names(col)

	gen n = _n
	replace n = 3*n-1

    ///graph  
	cap graph drop prefecture`i'
	gr set window fontface "Times New Roman" 
    gr set window fontfacesans "宋体"
		
	tw (rcap ul ll n if (type==0), lp(solid)) ///
       (scatter b n if (type==0), mc(black) msym(oh)) ///
       (rcap ul ll n if (type==1), lp(dash)) ///
       (scatter b n if (type==1), mc(black) msym(dh)) ///
	   (rcap ul ll n if (type==2), lp(shortdash_dot)) ///
       (scatter b n if (type==2), mc(black) msym(th)) ///
       (rcap ul ll n if (type==3), lp(longdash_dot)) ///
       (scatter b n if (type==3), mc(black) msym(sh)), ///
       $graph_opts ///
	   ylab(-.1(.1).7, labs(medlarge)) ///
	   xlab(2 "{stSans:工资总差异}" 5 "{stSans:禀赋效应}" 8 "{stSans:溢价效应}", notick labs(medsmall)) /// 
	   ti("{stSans:`prefecture`i''}", nobox pos(12) si(medlarge)) ///
	   yti("{stSans:差}""{stSans:值}", orientation(h) nobox place(9) si(medlarge)) ///
	   xti("") ///
	   ysc(r(-.15(.05).7) line) ///
	   xsc(r(0(1)10) line) ///
	   yline(0, lc(gs12) lp(dash)) ///
	   legend(on order(2 1) label(2 "{stSans:点估计值}") label(1 "{stSans:95%置信区间}") symy(*.25) r(1) si(small) span) ///
	   `yaxis_prefecture_`i'' ///
       name(prefecture`i')
}

///draw upper
cap graph drop upper
grc1leg prefecture1 prefecture2 prefecture3, ///
    r(1) ///
	graphregion(color(white)) ///
	leg(prefecture1) pos(6) span /// 
	name(upper) 
	
///draw lower
cap graph drop lower
grc1leg prefecture4 prefecture5 prefecture6, ///
    r(1) /// 
	graphregion(color(white)) /// 
	leg(prefecture4) pos(6) span ///
	name(lower) 

///draw whole
cap graph drop Graph 
grc1leg upper lower, ///
    r(2) ///
	graphregion(color(white)) ///
	leg(upper) pos(6) span 
gr save "Graph" "C:\Personal\study\research\2022.04 wage gap\cdr\code\hetero_prefecture_2.gph", replace
gr export "C:\Personal\study\research\2022.04 wage gap\cdr\result\heterogeneity analysis-prefecture.png", as(png) name("Graph") replace

cap graph drop _all


/*----------------------------------------------------------------------------*/


use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear 

loc prefecture1 "北京"
loc prefecture2 "上海"
loc prefecture3 "广州" 
loc prefecture4 "沈阳"
loc prefecture5 "西安"
loc prefecture6 "成都"

loc yaxis_prefecture_2 ylab(, notick labc(white) labs(medium)) yti("") ysc(noline)
loc yaxis_prefecture_3 ylab(, notick labc(white) labs(medium)) yti("") ysc(noline)
loc yaxis_prefecture_5 ylab(, notick labc(white) labs(medium)) yti("") ysc(noline)
loc yaxis_prefecture_6 ylab(, notick labc(white) labs(medium)) yti("") ysc(noline)

forv i = 1/6 {
    use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear 
		
	oaxaca9 lwr $hc $demo_dummy $occu_dummy $firm_conti_alter if (prefecture==`i'), by(soe) swap cat(cmarr*, cjobt*, csize*, cy*, cind1-cind5) p     
    if (`i'==1) outreg2 using decomp_ob_prefecture_alter_2, excel dec(3) ct("1") replace 
	else outreg2 using decomp_ob_prefecture_alter_2, excel dec(3) ct("`i'") append 
	
	mat drop _all
	///coe	
    mat b_`i'0 = e(b) 
    sca b_gap_`i'0 = b_`i'0[1, 3] 
    sca b_cha_`i'0 = b_`i'0[1, 4] 
    sca b_coe_`i'0 = b_`i'0[1, 5] 
	///ci 
	mat v_`i'0 = e(V)
    sca v_gap_`i'0 = v_`i'0[3, 3]
    sca v_cha_`i'0 = v_`i'0[4, 4] 
    sca v_coe_`i'0 = v_`i'0[5, 5] 
    sca ll_gap_`i'0 = b_gap_`i'0-1.96*sqrt(v_gap_`i'0) 
    sca ul_gap_`i'0 = b_gap_`i'0+1.96*sqrt(v_gap_`i'0)
    sca ll_cha_`i'0 = b_cha_`i'0-1.96*sqrt(v_cha_`i'0)
    sca ul_cha_`i'0 = b_cha_`i'0+1.96*sqrt(v_cha_`i'0)
    sca ll_coe_`i'0 = b_coe_`i'0-1.96*sqrt(v_coe_`i'0) 
    sca ul_coe_`i'0 = b_coe_`i'0+1.96*sqrt(v_coe_`i'0) 
    ///result matrix 
    mat result_0_gap = [b_gap_`i'0, ll_gap_`i'0, ul_gap_`i'0, 0] 
    mat result_0_cha = [b_cha_`i'0, ll_cha_`i'0, ul_cha_`i'0, 0]
    mat result_0_coe = [b_coe_`i'0, ll_coe_`i'0, ul_coe_`i'0, 0]
		
	foreach x in "gap" "cha" "coe" {
	    mat results = nullmat(results) \ result_0_`x'
	}
	
    mat colnames results = "b" "ll" "ul" "type" 
        
    clear
    svmat results, names(col)

	gen n = _n
	replace n = 3*n-1

    ///graph  
	cap graph drop prefecture`i'
	gr set window fontface "Times New Roman" 
    gr set window fontfacesans "宋体"
		
	tw (rcap ul ll n if (type==0), lp(solid)) ///
       (scatter b n if (type==0), mc(black) msym(oh)) ///
       (rcap ul ll n if (type==1), lp(dash)) ///
       (scatter b n if (type==1), mc(black) msym(dh)) ///
	   (rcap ul ll n if (type==2), lp(shortdash_dot)) ///
       (scatter b n if (type==2), mc(black) msym(th)) ///
       (rcap ul ll n if (type==3), lp(longdash_dot)) ///
       (scatter b n if (type==3), mc(black) msym(sh)), ///
       $graph_opts ///
	   ylab(-.1(.1).7, labs(medlarge)) ///
	   xlab(2 "{stSans:工资总差异}" 5 "{stSans:禀赋效应}" 8 "{stSans:溢价效应}", notick labs(medsmall)) /// 
	   ti("{stSans:`prefecture`i''}", nobox pos(12) si(medlarge)) ///
	   yti("{stSans:差}""{stSans:值}", orientation(h) nobox place(9) si(medlarge)) ///
	   xti("") ///
	   ysc(r(-.15(.05).7) line) ///
	   xsc(r(0(1)10) line) ///
	   yline(0, lc(gs12) lp(dash)) ///
	   legend(on order(2 1) label(2 "{stSans:点估计值}") label(1 "{stSans:95%置信区间}") symy(*.25) r(1) si(small) span) ///
	   `yaxis_prefecture_`i'' ///
       name(prefecture`i')
}

///draw upper
cap graph drop upper
grc1leg prefecture1 prefecture2 prefecture3, ///
    r(1) ///
	graphregion(color(white)) ///
	leg(prefecture1) pos(6) span /// 
	name(upper) 
	
///draw lower
cap graph drop lower
grc1leg prefecture4 prefecture5 prefecture6, ///
    r(1) /// 
	graphregion(color(white)) /// 
	leg(prefecture4) pos(6) span ///
	name(lower) 

///draw whole
cap graph drop Graph 
grc1leg upper lower, ///
    r(2) ///
	graphregion(color(white)) ///
	leg(upper) pos(6) span 
gr save "Graph" "C:\Personal\study\research\2022.04 wage gap\cdr\code\hetero_prefecture_alter_2.gph", replace
gr export "C:\Personal\study\research\2022.04 wage gap\cdr\result\heterogeneity analysis-prefecture_alter.png", as(png) name("Graph") replace

cap graph drop _all


/*----------------------------------------------------------------------------*/


/*cfps-area*/
use "C:\Personal\study\research\2021.10 soe & hr\cdr\data\maindata_4.dta", clear

forv i = 0/3 {   
    oaxaca9 wlwage exp exp2 female mino rhk leave mar kidnum pm size if (area==`i'), by(soe) swap cat(cedu*, cind*) p     
    
	mat drop _all
	mat b_`i' = e(b) 
	sca b_gap_`i' = b_`i'[1, 3]
	sca b_coe_`i' = b_`i'[1, 5]
	sca coeshare_`i' = b_coe_`i'/b_gap_`i'
	sca coesharestr_`i' = strofreal(coeshare_`i'*100, "%4.2f")+"%"
	
	
	if (`i'==0) outreg2 using hetero_cfps_area_2, excel dec(3) ct("0") replace 
	else outreg2 using hetero_cfps_area_2, excel dec(3) ct("`i'") append
}

tempfile table
tempname hetero_cfps_area_share

postfile `hetero_cfps_area_share' str200(share_0 share_1 share_2 share_3) using `table', replace 
post `hetero_cfps_area_share' (coesharestr_0) (coesharestr_1) (coesharestr_2) (coesharestr_3) 

postclose `hetero_cfps_area_share'
use `table', clear
export excel using hetero_cfps_area_share_2, replace firstrow(variables)


/*----------------------------------------------------------------------------*/


/*female*/ 
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear 

gl demo_dummy_female_ mino rural native mangood diagood phygood mengood pm child 

loc female0 "男性"
loc female1 "女性"

loc yaxis_female_1 ylab(, notick labc(white) labs(medium)) yti("") ysc(noline)

forv i = 0/1 {
    use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear 
	
	oaxaca9 lwr $hc $demo_dummy_female_ $occu_dummy $firm_conti $firm_dummy if (female==`i'), by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p    	
	if (`i'==0) {
		outreg2 using decomp_ob_female_wl_2, excel dec(3) ct("0-0") replace 
		outreg2 using decomp_ob_female_wlp_2, excel dec(3) ct("0-0") replace 
		outreg2 using decomp_ob_female_wlpp_2, excel dec(3) ct("0-0") replace
	}
	else {
		outreg2 using decomp_ob_female_wl_2, excel dec(3) ct("`i'-0") append 
		outreg2 using decomp_ob_female_wlp_2, excel dec(3) ct("`i'-0") append 
		outreg2 using decomp_ob_female_wlpp_2, excel dec(3) ct("`i'-0") append
	} 
	
	mat drop _all
	///coe
    mat b_`i'0 = e(b) 
    sca b_gap_`i'0 = b_`i'0[1, 3] 
    sca b_cha_`i'0 = b_`i'0[1, 4] 
    sca b_coe_`i'0 = b_`i'0[1, 5] 
    ///ci
    mat v_`i'0 = e(V)
    sca v_gap_`i'0 = v_`i'0[3, 3]
    sca v_cha_`i'0 = v_`i'0[4, 4] 
    sca v_coe_`i'0 = v_`i'0[5, 5] 
    sca ll_gap_`i'0 = b_gap_`i'0-1.96*sqrt(v_gap_`i'0) 
    sca ul_gap_`i'0 = b_gap_`i'0+1.96*sqrt(v_gap_`i'0)
    sca ll_cha_`i'0 = b_cha_`i'0-1.96*sqrt(v_cha_`i'0)
    sca ul_cha_`i'0 = b_cha_`i'0+1.96*sqrt(v_cha_`i'0)
    sca ll_coe_`i'0 = b_coe_`i'0-1.96*sqrt(v_coe_`i'0) 
    sca ul_coe_`i'0 = b_coe_`i'0+1.96*sqrt(v_coe_`i'0) 
    ///result matrix
	foreach wl in "wl" "wlp" "wlpp" {
		mat result_0_gap_`wl' = [b_gap_`i'0, ll_gap_`i'0, ul_gap_`i'0, 0] 
        mat result_0_cha_`wl' = [b_cha_`i'0, ll_cha_`i'0, ul_cha_`i'0, 0]
        mat result_0_coe_`wl' = [b_coe_`i'0, ll_coe_`i'0, ul_coe_`i'0, 0]
	}
	

    {
	forv j = 1/2 {
	    oaxaca9 lwr $hc $demo_dummy_female_ $occu_dummy $firm_conti $firm_dummy if (female==`i') & (wl==`j'), by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p 
		outreg2 using decomp_ob_female_wl_2, excel dec(3) ct("`i'-`j'") append
		
		///coe 
		mat b_`i'`j'_wl = e(b) 
		sca b_gap_`i'`j'_wl = b_`i'`j'_wl[1, 3]
		sca b_cha_`i'`j'_wl = b_`i'`j'_wl[1, 4]
	    sca b_coe_`i'`j'_wl = b_`i'`j'_wl[1, 5] 
        ///ci		
		mat v_`i'`j'_wl = e(V)
        sca v_gap_`i'`j'_wl = v_`i'`j'_wl[3, 3]
        sca v_cha_`i'`j'_wl = v_`i'`j'_wl[4, 4] 
        sca v_coe_`i'`j'_wl = v_`i'`j'_wl[5, 5] 
        sca ll_gap_`i'`j'_wl = b_gap_`i'`j'_wl-1.96*sqrt(v_gap_`i'`j'_wl) 
        sca ul_gap_`i'`j'_wl = b_gap_`i'`j'_wl+1.96*sqrt(v_gap_`i'`j'_wl)
        sca ll_cha_`i'`j'_wl = b_cha_`i'`j'_wl-1.96*sqrt(v_cha_`i'`j'_wl)
        sca ul_cha_`i'`j'_wl = b_cha_`i'`j'_wl+1.96*sqrt(v_cha_`i'`j'_wl)
        sca ll_coe_`i'`j'_wl = b_coe_`i'`j'_wl-1.96*sqrt(v_coe_`i'`j'_wl) 
        sca ul_coe_`i'`j'_wl = b_coe_`i'`j'_wl+1.96*sqrt(v_coe_`i'`j'_wl) 
        ///result matrix
        mat result_`j'_gap_wl = [b_gap_`i'`j'_wl, ll_gap_`i'`j'_wl, ul_gap_`i'`j'_wl, `j'] 
        mat result_`j'_cha_wl = [b_cha_`i'`j'_wl, ll_cha_`i'`j'_wl, ul_cha_`i'`j'_wl, `j']
        mat result_`j'_coe_wl = [b_coe_`i'`j'_wl, ll_coe_`i'`j'_wl, ul_coe_`i'`j'_wl, `j']
	}
	
	foreach x in "gap" "cha" "coe" {
        forv j = 0/2 {
	        mat results_wl = nullmat(results_wl) \ result_`j'_`x'_wl
	    }
    }

    mat colnames results_wl = "b" "ll" "ul" "type" 
        
    clear
    svmat results_wl, names(col)

	gen n = _n

    ///graph 
    cap graph drop female`i'_wl
	gr set window fontface "Times New Roman" 
    gr set window fontfacesans "宋体"
		
	tw (rcap ul ll n if (type==0), lc(black) lp(solid)) ///
       (scatter b n if (type==0), mc(black) msym(oh)) ///
       (rcap ul ll n if (type==1), lc(black) lp(dash)) ///
       (scatter b n if (type==1), mc(black) msym(dh)) ///
	   (rcap ul ll n if (type==2), lc(black) lp(shortdash_dot)) ///
       (scatter b n if (type==2), mc(black) msym(th)), ///
       $graph_opts ///
	   ylab(-.1(.1).4, labs(medlarge)) ///
	   xlab(2 "{stSans:工资总差异}" 5 "{stSans:禀赋效应}" 8 "{stSans:溢价效应}", notick labs(med)) /// 
	   ti("{stSans:`female`i''}", nobox pos(12) si(medlarge)) ///
	   yti("{stSans:差}""{stSans:值}", orientation(h) nobox place(9) si(medlarge)) ///
	   xti("") ///
	   ysc(r(-.1(.05).45) line) ///
	   xsc(r(0(1)10) line) ///
	   yline(0, lc(gs12) lp(dash)) ///
	   legend(on order(2 4 6 1 3 5) label(2 "{stSans:点估计值：全体}") label(4 "{stSans:点估计值：低工资}") label(6 "{stSans:点估计值：高工资}") label(1 "{stSans:95%置信区间：全体}") label(3 "{stSans:95%置信区间：低工资}") label(5 "{stSans:95%置信区间：高工资}") symy(*.25) r(2) si(small) span) ///
       `yaxis_female_`i'' ///
	   name(female`i'_wl)
    }
	    
	 
	{
	use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear 
	
	forv k = 1/3 {
	    oaxaca9 lwr $hc $demo_dummy_female_ $occu_dummy $firm_conti $firm_dummy if (female==`i') & (wlp==`k'), by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p 
		outreg2 using decomp_ob_female_wlp_2, excel dec(3) ct("`i'-`k'") append 
		
		///coe 
		mat b_`i'`k'_wlp = e(b) 
		sca b_gap_`i'`k'_wlp = b_`i'`k'_wlp[1, 3]
		sca b_cha_`i'`k'_wlp = b_`i'`k'_wlp[1, 4]
	    sca b_coe_`i'`k'_wlp = b_`i'`k'_wlp[1, 5] 
        ///ci		
		mat v_`i'`k'_wlp = e(V)
        sca v_gap_`i'`k'_wlp = v_`i'`k'_wlp[3, 3]
        sca v_cha_`i'`k'_wlp = v_`i'`k'_wlp[4, 4] 
        sca v_coe_`i'`k'_wlp = v_`i'`k'_wlp[5, 5] 
        sca ll_gap_`i'`k'_wlp = b_gap_`i'`k'_wlp-1.96*sqrt(v_gap_`i'`k'_wlp) 
        sca ul_gap_`i'`k'_wlp = b_gap_`i'`k'_wlp+1.96*sqrt(v_gap_`i'`k'_wlp)
        sca ll_cha_`i'`k'_wlp = b_cha_`i'`k'_wlp-1.96*sqrt(v_cha_`i'`k'_wlp)
        sca ul_cha_`i'`k'_wlp = b_cha_`i'`k'_wlp+1.96*sqrt(v_cha_`i'`k'_wlp)
        sca ll_coe_`i'`k'_wlp = b_coe_`i'`k'_wlp-1.96*sqrt(v_coe_`i'`k'_wlp) 
        sca ul_coe_`i'`k'_wlp = b_coe_`i'`k'_wlp+1.96*sqrt(v_coe_`i'`k'_wlp) 
        ///result matrix
        mat result_`k'_gap_wlp = [b_gap_`i'`k'_wlp, ll_gap_`i'`k'_wlp, ul_gap_`i'`k'_wlp, `k'] 
        mat result_`k'_cha_wlp = [b_cha_`i'`k'_wlp, ll_cha_`i'`k'_wlp, ul_cha_`i'`k'_wlp, `k']
        mat result_`k'_coe_wlp = [b_coe_`i'`k'_wlp, ll_coe_`i'`k'_wlp, ul_coe_`i'`k'_wlp, `k']
	}
	
	foreach x in "gap" "cha" "coe" {
        forv k = 0/3 {
	        mat results_wlp = nullmat(results_wlp) \ result_`k'_`x'_wlp
	    }
    }

    mat colnames results_wlp = "b" "ll" "ul" "type" 
        
    clear
    svmat results_wlp, names(col)

	gen n = _n

    ///graph 
    cap graph drop female`i'_wlp
	gr set window fontface "Times New Roman" 
    gr set window fontfacesans "宋体"
		
	tw (rcap ul ll n if (type==0), lc(black) lp(solid)) ///
       (scatter b n if (type==0), mc(black) msym(oh)) ///
       (rcap ul ll n if (type==1), lc(black) lp(dash)) ///
       (scatter b n if (type==1), mc(black) msym(dh)) ///
	   (rcap ul ll n if (type==2), lc(black) lp(longdash_dot)) ///
       (scatter b n if (type==2), mc(black) msym(sh)) ///
	   (rcap ul ll n if (type==3), lc(black) lp(shortdash_dot)) ///
       (scatter b n if (type==3), mc(black) msym(th)), ///
       $graph_opts ///
	   ylab(-.1(.1).4, labs(medlarge)) ///
	   xlab(3 "{stSans:工资总差异}" 6.5 "{stSans:禀赋效应}" 10 "{stSans:溢价效应}", notick labs(med)) /// 
	   ti("{stSans:`female`i''}", nobox pos(12) si(medlarge)) ///
	   yti("{stSans:差}""{stSans:值}", orientation(h) nobox place(9) si(medlarge)) ///
	   xti("") ///
	   ysc(r(-.1(.05).45) line) ///
	   xsc(r(0(1)13) line) ///
	   yline(0, lc(gs12) lp(dash)) ///
	   legend(on order(1 2 3 4 5 6 7 8) label(1 "{stSans:95%置信区间：全体}") label(2 "{stSans:点估计值：全体}") label(3 "{stSans:95%置信区间：低工资}") label(4 "{stSans:点估计值：低工资}") label(5 "{stSans:95%置信区间：中等工资}") label(6 "{stSans:点估计值：中等工资}") label(7 "{stSans:95%置信区间：高工资}") label(8 "{stSans:点估计值：高工资}") symy(*.25) r(2) si(small) span) ///
       `yaxis_female_`i'' ///
	   name(female`i'_wlp)
	}

	
	{
	use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear
	
	forv l = 1/2 {
	    oaxaca9 lwr $hc $demo_dummy_female_ $occu_dummy $firm_conti $firm_dummy if (female==`i') & (wlpp==`l'), by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p 
		outreg2 using decomp_ob_female_wlpp_2, excel dec(3) ct("`i'-`l'") append
		
		///coe 
		mat b_`i'`l'_wlpp = e(b) 
		sca b_gap_`i'`l'_wlpp = b_`i'`l'_wlpp[1, 3]
		sca b_cha_`i'`l'_wlpp = b_`i'`l'_wlpp[1, 4]
	    sca b_coe_`i'`l'_wlpp = b_`i'`l'_wlpp[1, 5] 
        ///ci		
		mat v_`i'`l'_wlpp = e(V)
        sca v_gap_`i'`l'_wlpp = v_`i'`l'_wlpp[3, 3]
        sca v_cha_`i'`l'_wlpp = v_`i'`l'_wlpp[4, 4] 
        sca v_coe_`i'`l'_wlpp = v_`i'`l'_wlpp[5, 5] 
        sca ll_gap_`i'`l'_wlpp = b_gap_`i'`l'_wlpp-1.96*sqrt(v_gap_`i'`l'_wlpp) 
        sca ul_gap_`i'`l'_wlpp = b_gap_`i'`l'_wlpp+1.96*sqrt(v_gap_`i'`l'_wlpp)
        sca ll_cha_`i'`l'_wlpp = b_cha_`i'`l'_wlpp-1.96*sqrt(v_cha_`i'`l'_wlpp)
        sca ul_cha_`i'`l'_wlpp = b_cha_`i'`l'_wlpp+1.96*sqrt(v_cha_`i'`l'_wlpp)
        sca ll_coe_`i'`l'_wlpp = b_coe_`i'`l'_wlpp-1.96*sqrt(v_coe_`i'`l'_wlpp) 
        sca ul_coe_`i'`l'_wlpp = b_coe_`i'`l'_wlpp+1.96*sqrt(v_coe_`i'`l'_wlpp) 
        ///result matrix
        mat result_`l'_gap_wlpp = [b_gap_`i'`l'_wlpp, ll_gap_`i'`l'_wlpp, ul_gap_`i'`l'_wlpp, `l'] 
        mat result_`l'_cha_wlpp = [b_cha_`i'`l'_wlpp, ll_cha_`i'`l'_wlpp, ul_cha_`i'`l'_wlpp, `l']
        mat result_`l'_coe_wlpp = [b_coe_`i'`l'_wlpp, ll_coe_`i'`l'_wlpp, ul_coe_`i'`l'_wlpp, `l']
	}
	
	foreach x in "gap" "cha" "coe" {
        forv l = 0/2 {
	        mat results_wlpp = nullmat(results_wlpp) \ result_`l'_`x'_wlpp
	    }
    }

    mat colnames results_wlpp = "b" "ll" "ul" "type" 
        
    clear
    svmat results_wlpp, names(col)

	gen n = _n

    ///graph 
    cap graph drop female`i'_wlpp
	gr set window fontface "Times New Roman" 
    gr set window fontfacesans "宋体"
		
	tw (rcap ul ll n if (type==0), lc(black) lp(solid)) ///
       (scatter b n if (type==0), mc(black) msym(oh)) ///
       (rcap ul ll n if (type==1), lc(black) lp(dash)) ///
       (scatter b n if (type==1), mc(black) msym(dh)) ///
	   (rcap ul ll n if (type==2), lc(black) lp(shortdash_dot)) ///
       (scatter b n if (type==2), mc(black) msym(th)), ///
       $graph_opts ///
	   ylab(0(.1).4, labs(medlarge)) ///
	   xlab(2 "{stSans:工资总差异}" 5 "{stSans:禀赋效应}" 8 "{stSans:溢价效应}", notick labs(med)) /// 
	   ti("{stSans:`female`i''}", nobox pos(12) si(medlarge)) ///
	   yti("{stSans:差}""{stSans:值}", orientation(h) nobox place(9) si(medlarge)) ///
	   xti("") ///
	   ysc(r(-.05(.05).45) line) ///
	   xsc(r(0(1)10) line) ///
	   yline(0, lc(gs12) lp(dash)) ///
	   legend(on order(2 4 6 1 3 5) label(2 "{stSans:点估计值：全体}") label(4 "{stSans:点估计值：低工资}") label(6 "{stSans:点估计值：中高工资}") label(1 "{stSans:95%置信区间：全体}") label(3 "{stSans:95%置信区间：低工资}") label(5 "{stSans:95%置信区间：中高工资}") symy(*.25) r(2) si(small) span) ///
       `yaxis_female_`i'' ///
	   name(female`i'_wlpp)
    }
}

///draw female 
cap graph drop female_wl
grc1leg female0_wl female1_wl, ///
    r(1) ///
	graphregion(color(white)) /// 
    ti("{stSans:1．按性别}", nobox pos(11) si(medium)) ///
	leg(female0_wl) pos(6) span ///
	name(female_wl) 
	
cap graph drop female_wlp
grc1leg female0_wlp female1_wlp, ///
    r(1) ///
	graphregion(color(white)) /// 
    ti("{stSans:1．按性别}", nobox pos(11) si(medium)) ///
	leg(female0_wlp) pos(6) span ///
	name(female_wlp) 

cap graph drop female_wlpp
grc1leg female0_wlpp female1_wlpp, ///
    r(1) ///
	graphregion(color(white)) /// 
    ti("{stSans:1．按性别}", nobox pos(11) si(medium)) ///
	leg(female0_wlpp) pos(6) span ///
	name(female_wlpp) 


/*rural*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear 

gl demo_dummy_rural_ female mino native mangood diagood phygood mengood pm child 

loc rural0 "非农户口"
loc rural1 "农业户口" 

loc yaxis_rural_1 ylab(, notick labc(white) labs(medium)) yti("") ysc(noline)


forv i = 0/1 {
    use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear 
		
	oaxaca9 lwr $hc $demo_dummy_rural_ $occu_dummy $firm_conti $firm_dummy if (rural==`i'), by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p     
	if (`i'==0) {
		outreg2 using decomp_ob_rural_wl_2, excel dec(3) ct("0-0") replace 
		outreg2 using decomp_ob_rural_wlp_2, excel dec(3) ct("0-0") replace 
		outreg2 using decomp_ob_rural_wlpp_2, excel dec(3) ct("0-0") replace
	}
	else {
		outreg2 using decomp_ob_rural_wl_2, excel dec(3) ct("`i'-0") append 
		outreg2 using decomp_ob_rural_wlp_2, excel dec(3) ct("`i'-0") append 
		outreg2 using decomp_ob_rural_wlpp_2, excel dec(3) ct("`i'-0") append
	} 
	
	mat drop _all
	///coe
    mat b_`i'0 = e(b) 
    sca b_gap_`i'0 = b_`i'0[1, 3] 
    sca b_cha_`i'0 = b_`i'0[1, 4] 
    sca b_coe_`i'0 = b_`i'0[1, 5] 
    ///ci
    mat v_`i'0 = e(V)
    sca v_gap_`i'0 = v_`i'0[3, 3]
    sca v_cha_`i'0 = v_`i'0[4, 4] 
    sca v_coe_`i'0 = v_`i'0[5, 5] 
    sca ll_gap_`i'0 = b_gap_`i'0-1.96*sqrt(v_gap_`i'0) 
    sca ul_gap_`i'0 = b_gap_`i'0+1.96*sqrt(v_gap_`i'0)
    sca ll_cha_`i'0 = b_cha_`i'0-1.96*sqrt(v_cha_`i'0)
    sca ul_cha_`i'0 = b_cha_`i'0+1.96*sqrt(v_cha_`i'0)
    sca ll_coe_`i'0 = b_coe_`i'0-1.96*sqrt(v_coe_`i'0) 
    sca ul_coe_`i'0 = b_coe_`i'0+1.96*sqrt(v_coe_`i'0) 
    ///result matrix
	foreach wl in "wl" "wlp" "wlpp" {
		mat result_0_gap_`wl' = [b_gap_`i'0, ll_gap_`i'0, ul_gap_`i'0, 0] 
        mat result_0_cha_`wl' = [b_cha_`i'0, ll_cha_`i'0, ul_cha_`i'0, 0]
        mat result_0_coe_`wl' = [b_coe_`i'0, ll_coe_`i'0, ul_coe_`i'0, 0]
	}

	
	{
	forv j = 1/2 {
	    oaxaca9 lwr $hc $demo_dummy_rural_ $occu_dummy $firm_conti $firm_dummy if (female==`i') & (wl==`j'), by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p 
		outreg2 using decomp_ob_rural_wl_2, excel dec(3) ct("`i'-`j'") append
		
		///coe 
		mat b_`i'`j'_wl = e(b) 
		sca b_gap_`i'`j'_wl = b_`i'`j'_wl[1, 3]
		sca b_cha_`i'`j'_wl = b_`i'`j'_wl[1, 4]
	    sca b_coe_`i'`j'_wl = b_`i'`j'_wl[1, 5] 
        ///ci		
		mat v_`i'`j'_wl = e(V)
        sca v_gap_`i'`j'_wl = v_`i'`j'_wl[3, 3]
        sca v_cha_`i'`j'_wl = v_`i'`j'_wl[4, 4] 
        sca v_coe_`i'`j'_wl = v_`i'`j'_wl[5, 5] 
        sca ll_gap_`i'`j'_wl = b_gap_`i'`j'_wl-1.96*sqrt(v_gap_`i'`j'_wl) 
        sca ul_gap_`i'`j'_wl = b_gap_`i'`j'_wl+1.96*sqrt(v_gap_`i'`j'_wl)
        sca ll_cha_`i'`j'_wl = b_cha_`i'`j'_wl-1.96*sqrt(v_cha_`i'`j'_wl)
        sca ul_cha_`i'`j'_wl = b_cha_`i'`j'_wl+1.96*sqrt(v_cha_`i'`j'_wl)
        sca ll_coe_`i'`j'_wl = b_coe_`i'`j'_wl-1.96*sqrt(v_coe_`i'`j'_wl) 
        sca ul_coe_`i'`j'_wl = b_coe_`i'`j'_wl+1.96*sqrt(v_coe_`i'`j'_wl) 
        ///result matrix
        mat result_`j'_gap_wl = [b_gap_`i'`j'_wl, ll_gap_`i'`j'_wl, ul_gap_`i'`j'_wl, `j'] 
        mat result_`j'_cha_wl = [b_cha_`i'`j'_wl, ll_cha_`i'`j'_wl, ul_cha_`i'`j'_wl, `j']
        mat result_`j'_coe_wl = [b_coe_`i'`j'_wl, ll_coe_`i'`j'_wl, ul_coe_`i'`j'_wl, `j']
	}
	
	foreach x in "gap" "cha" "coe" {
        forv j = 0/2 {
	        mat results_wl = nullmat(results_wl) \ result_`j'_`x'_wl
	    }
    }

    mat colnames results_wl = "b" "ll" "ul" "type" 
        
    clear
    svmat results_wl, names(col)

	gen n = _n

    ///graph 
    cap graph drop rural`i'_wl
	gr set window fontface "Times New Roman" 
    gr set window fontfacesans "宋体"
		
	tw (rcap ul ll n if (type==0), lc(black) lp(solid)) ///
       (scatter b n if (type==0), mc(black) msym(oh)) ///
       (rcap ul ll n if (type==1), lc(black) lp(dash)) ///
       (scatter b n if (type==1), mc(black) msym(dh)) ///
	   (rcap ul ll n if (type==2), lc(black) lp(shortdash_dot)) ///
       (scatter b n if (type==2), mc(black) msym(th)), ///
       $graph_opts ///
	   ylab(-.1(.1).4, labs(medlarge)) ///
	   xlab(2 "{stSans:工资总差异}" 5 "{stSans:禀赋效应}" 8 "{stSans:溢价效应}", notick labs(med)) /// 
	   ti("{stSans:`female`i''}", nobox pos(12) si(medlarge)) ///
	   yti("{stSans:差}""{stSans:值}", orientation(h) nobox place(9) si(medlarge)) ///
	   xti("") ///
	   ysc(r(-.1(.05).45) line) ///
	   xsc(r(0(1)10) line) ///
	   yline(0, lc(gs12) lp(dash)) ///
	   legend(on order(2 4 6 1 3 5) label(2 "{stSans:点估计值：全体}") label(4 "{stSans:点估计值：低工资}") label(6 "{stSans:点估计值：高工资}") label(1 "{stSans:95%置信区间：全体}") label(3 "{stSans:95%置信区间：低工资}") label(5 "{stSans:95%置信区间：高工资}") symy(*.25) r(2) si(small) span) ///
       `yaxis_rural_`i'' ///
	   name(rural`i'_wl)
    }

	
	{
	use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear 
	
	forv k = 1/3 {
	    oaxaca9 lwr $hc $demo_dummy_rural_ $occu_dummy $firm_conti $firm_dummy if (female==`i') & (wlp==`k'), by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p 
		outreg2 using decomp_ob_rural_wlp_2, excel dec(3) ct("`i'-`k'") append 
		
		///coe 
		mat b_`i'`k'_wlp = e(b) 
		sca b_gap_`i'`k'_wlp = b_`i'`k'_wlp[1, 3]
		sca b_cha_`i'`k'_wlp = b_`i'`k'_wlp[1, 4]
	    sca b_coe_`i'`k'_wlp = b_`i'`k'_wlp[1, 5] 
        ///ci		
		mat v_`i'`k'_wlp = e(V)
        sca v_gap_`i'`k'_wlp = v_`i'`k'_wlp[3, 3]
        sca v_cha_`i'`k'_wlp = v_`i'`k'_wlp[4, 4] 
        sca v_coe_`i'`k'_wlp = v_`i'`k'_wlp[5, 5] 
        sca ll_gap_`i'`k'_wlp = b_gap_`i'`k'_wlp-1.96*sqrt(v_gap_`i'`k'_wlp) 
        sca ul_gap_`i'`k'_wlp = b_gap_`i'`k'_wlp+1.96*sqrt(v_gap_`i'`k'_wlp)
        sca ll_cha_`i'`k'_wlp = b_cha_`i'`k'_wlp-1.96*sqrt(v_cha_`i'`k'_wlp)
        sca ul_cha_`i'`k'_wlp = b_cha_`i'`k'_wlp+1.96*sqrt(v_cha_`i'`k'_wlp)
        sca ll_coe_`i'`k'_wlp = b_coe_`i'`k'_wlp-1.96*sqrt(v_coe_`i'`k'_wlp) 
        sca ul_coe_`i'`k'_wlp = b_coe_`i'`k'_wlp+1.96*sqrt(v_coe_`i'`k'_wlp) 
        ///result matrix
        mat result_`k'_gap_wlp = [b_gap_`i'`k'_wlp, ll_gap_`i'`k'_wlp, ul_gap_`i'`k'_wlp, `k'] 
        mat result_`k'_cha_wlp = [b_cha_`i'`k'_wlp, ll_cha_`i'`k'_wlp, ul_cha_`i'`k'_wlp, `k']
        mat result_`k'_coe_wlp = [b_coe_`i'`k'_wlp, ll_coe_`i'`k'_wlp, ul_coe_`i'`k'_wlp, `k']
	}
	
	foreach x in "gap" "cha" "coe" {
        forv k = 0/3 {
	        mat results_wlp = nullmat(results_wlp) \ result_`k'_`x'_wlp
	    }
    }

    mat colnames results_wlp = "b" "ll" "ul" "type" 
        
    clear
    svmat results_wlp, names(col)

	gen n = _n

    ///graph 
    cap graph drop rural`i'_wlp
	gr set window fontface "Times New Roman" 
    gr set window fontfacesans "宋体"
		
	tw (rcap ul ll n if (type==0), lc(black) lp(solid)) ///
       (scatter b n if (type==0), mc(black) msym(oh)) ///
       (rcap ul ll n if (type==1), lc(black) lp(dash)) ///
       (scatter b n if (type==1), mc(black) msym(dh)) ///
	   (rcap ul ll n if (type==2), lc(black) lp(longdash_dot)) ///
       (scatter b n if (type==2), mc(black) msym(sh)) ///
	   (rcap ul ll n if (type==3), lc(black) lp(shortdash_dot)) ///
       (scatter b n if (type==3), mc(black) msym(th)), ///
       $graph_opts ///
	   ylab(-.1(.1).4, labs(medlarge)) ///
	   xlab(3 "{stSans:工资总差异}" 6.5 "{stSans:禀赋效应}" 10 "{stSans:溢价效应}", notick labs(med)) /// 
	   ti("{stSans:`female`i''}", nobox pos(12) si(medlarge)) ///
	   yti("{stSans:差}""{stSans:值}", orientation(h) nobox place(9) si(medlarge)) ///
	   xti("") ///
	   ysc(r(-.1(.05).45) line) ///
	   xsc(r(0(1)13) line) ///
	   yline(0, lc(gs12) lp(dash)) ///
	   legend(on order(1 2 3 4 5 6 7 8) label(1 "{stSans:95%置信区间：全体}") label(2 "{stSans:点估计值：全体}") label(3 "{stSans:95%置信区间：低工资}") label(4 "{stSans:点估计值：低工资}") label(5 "{stSans:95%置信区间：中等工资}") label(6 "{stSans:点估计值：中等工资}") label(7 "{stSans:95%置信区间：高工资}") label(8 "{stSans:点估计值：高工资}") symy(*.25) r(2) si(small) span) ///
       `yaxis_rural_`i'' ///
	   name(rural`i'_wlp)
	}

	
	{
	use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear
	
	forv l = 1/2 {
	    oaxaca9 lwr $hc $demo_dummy_rural_ $occu_dummy $firm_conti $firm_dummy if (female==`i') & (wlpp==`l'), by(soe) swap cat(cmarr*, cjobt*, csize*, cedul_ceo*, cy*, cind1-cind5, cprefecture*, cp?_y?) p 
		outreg2 using decomp_ob_rural_wlpp_2, excel dec(3) ct("`i'-`l'") append
		
		///coe 
		mat b_`i'`l'_wlpp = e(b) 
		sca b_gap_`i'`l'_wlpp = b_`i'`l'_wlpp[1, 3]
		sca b_cha_`i'`l'_wlpp = b_`i'`l'_wlpp[1, 4]
	    sca b_coe_`i'`l'_wlpp = b_`i'`l'_wlpp[1, 5] 
        ///ci		
		mat v_`i'`l'_wlpp = e(V)
        sca v_gap_`i'`l'_wlpp = v_`i'`l'_wlpp[3, 3]
        sca v_cha_`i'`l'_wlpp = v_`i'`l'_wlpp[4, 4] 
        sca v_coe_`i'`l'_wlpp = v_`i'`l'_wlpp[5, 5] 
        sca ll_gap_`i'`l'_wlpp = b_gap_`i'`l'_wlpp-1.96*sqrt(v_gap_`i'`l'_wlpp) 
        sca ul_gap_`i'`l'_wlpp = b_gap_`i'`l'_wlpp+1.96*sqrt(v_gap_`i'`l'_wlpp)
        sca ll_cha_`i'`l'_wlpp = b_cha_`i'`l'_wlpp-1.96*sqrt(v_cha_`i'`l'_wlpp)
        sca ul_cha_`i'`l'_wlpp = b_cha_`i'`l'_wlpp+1.96*sqrt(v_cha_`i'`l'_wlpp)
        sca ll_coe_`i'`l'_wlpp = b_coe_`i'`l'_wlpp-1.96*sqrt(v_coe_`i'`l'_wlpp) 
        sca ul_coe_`i'`l'_wlpp = b_coe_`i'`l'_wlpp+1.96*sqrt(v_coe_`i'`l'_wlpp) 
        ///result matrix
        mat result_`l'_gap_wlpp = [b_gap_`i'`l'_wlpp, ll_gap_`i'`l'_wlpp, ul_gap_`i'`l'_wlpp, `l'] 
        mat result_`l'_cha_wlpp = [b_cha_`i'`l'_wlpp, ll_cha_`i'`l'_wlpp, ul_cha_`i'`l'_wlpp, `l']
        mat result_`l'_coe_wlpp = [b_coe_`i'`l'_wlpp, ll_coe_`i'`l'_wlpp, ul_coe_`i'`l'_wlpp, `l']
	}
	
	foreach x in "gap" "cha" "coe" {
        forv l = 0/2 {
	        mat results_wlpp = nullmat(results_wlpp) \ result_`l'_`x'_wlpp
	    }
    }

    mat colnames results_wlpp = "b" "ll" "ul" "type" 
        
    clear
    svmat results_wlpp, names(col)

	gen n = _n

    ///graph 
    cap graph drop rural`i'_wlpp
	gr set window fontface "Times New Roman" 
    gr set window fontfacesans "宋体"
		
	tw (rcap ul ll n if (type==0), lc(black) lp(solid)) ///
       (scatter b n if (type==0), mc(black) msym(oh)) ///
       (rcap ul ll n if (type==1), lc(black) lp(dash)) ///
       (scatter b n if (type==1), mc(black) msym(dh)) ///
	   (rcap ul ll n if (type==2), lc(black) lp(shortdash_dot)) ///
       (scatter b n if (type==2), mc(black) msym(th)), ///
       $graph_opts ///
	   ylab(0(.1).4, labs(medlarge)) ///
	   xlab(2 "{stSans:工资总差异}" 5 "{stSans:禀赋效应}" 8 "{stSans:溢价效应}", notick labs(med)) /// 
	   ti("{stSans:`female`i''}", nobox pos(12) si(medlarge)) ///
	   yti("{stSans:差}""{stSans:值}", orientation(h) nobox place(9) si(medlarge)) ///
	   xti("") ///
	   ysc(r(-.05(.05).45) line) ///
	   xsc(r(0(1)10) line) ///
	   yline(0, lc(gs12) lp(dash)) ///
	   legend(on order(2 4 6 1 3 5) label(2 "{stSans:点估计值：全体}") label(4 "{stSans:点估计值：低工资}") label(6 "{stSans:点估计值：中高工资}") label(1 "{stSans:95%置信区间：全体}") label(3 "{stSans:95%置信区间：低工资}") label(5 "{stSans:95%置信区间：中高工资}") symy(*.25) r(2) si(small) span) ///
       `yaxis_rural_`i'' ///
	   name(rural`i'_wlpp)
    }
}

///draw rural 
cap graph drop rural_wl
grc1leg rural0_wl rural1_wl, ///
    r(1) ///
	graphregion(color(white)) /// 
    ti("{stSans:2．按城乡}", nobox pos(11) si(medium)) ///
	leg(rural0_wl) pos(6) span ///
	name(rural_wl) 

cap graph drop rural_wlp
grc1leg rural0_wlp rural1_wlp, ///
    r(1) ///
	graphregion(color(white)) /// 
    ti("{stSans:2．按城乡}", nobox pos(11) si(medium)) ///
	leg(rural0_wlp) pos(6) span ///
	name(rural_wlp) 

cap graph drop rural_wlpp
grc1leg rural0_wlpp rural1_wlpp, ///
    r(1) ///
	graphregion(color(white)) /// 
    ti("{stSans:2．按城乡}", nobox pos(11) si(medium)) ///
	leg(rural0_wlpp) pos(6) span ///
	name(rural_wlpp) 
	

///draw whole 
foreach wl in "wl" "wlp" "wlpp" {
	cap graph drop Graph 
    grc1leg female_`wl' rural_`wl', ///
        r(2) ///
	    graphregion(color(white)) /// 
	    leg(female_`wl') pos(6) span 
    gr save "Graph" "C:\Personal\study\research\2022.04 wage gap\cdr\code/hetero_demo_`wl'_2.gph", replace
    gr export "C:\Personal\study\research\2022.04 wage gap\cdr\result/heterogeneity analysis-demo_`wl'.png", as(png) name("Graph") replace
}

cap graph drop _all


/*interaction term*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear

gen f_s = female*soe
gen r_s = rural*soe 

foreach x in "f_s" "r_s" {
    reg lwr soe $hc $demo $occu $firm $fe `x', r 
	if ("`x'"=="f_s") {
		outreg2 using reg_inter_wl_2, excel dec(3) ct("f_s-0") replace 
		outreg2 using reg_inter_wlp_2, excel dec(3) ct("f_s-0") replace 
		outreg2 using reg_inter_wlpp_2, excel dec(3) ct("f_s-0") replace
	}
	else {
		outreg2 using reg_inter_wl_2, excel dec(3) ct("`x'-0") append 
		outreg2 using reg_inter_wlp_2, excel dec(3) ct("`x'-0") append 
		outreg2 using reg_inter_wlpp_2, excel dec(3) ct("`x'-0") append
	}
	
	forv i = 1/2 {
	    reg lwr soe $hc $demo $occu $firm $fe `x' if (wl==`i'), r 
		outreg2 using reg_inter_wl_2, excel dec(3) ct("`x'-`i'") append
	}
    
	forv j = 1/3 {
		reg lwr soe $hc $demo $occu $firm $fe `x' if (wlp==`j'), r 
		outreg2 using reg_inter_wlp_2, excel dec(3) ct("`x'-`j'") append
	}
    
	forv k = 1/2 {
	    reg lwr soe $hc $demo $occu $firm $fe `x' if (wlpp==`k'), r 
		outreg2 using reg_inter_wlpp_2, excel dec(3) ct("`x'-`k'") append
	}
} 


/*by group*/
use "C:\Personal\study\research\2022.04 wage gap\cdr\data\maindata_hetero_2.dta", clear

forv i = 0/1 {
    reg lwr $hc $demo $occu $firm $fe if (soe==`i'), r
	if (`i'==0) outreg2 using reg_bygroup_2, excel dec(3) ct("0") replace 
	else outreg2 using reg_bygroup_2, excel dec(3) ct("1") append 
	
	forv j = 1/2 {
	    reg lwr $hc $demo $occu $firm $fe if (soe==`i') & (wl==`j'), r
		outreg2 using reg_bygroup_2, excel dec(3) ct("`i'-`j'") append
	}
}


